checkRequire("Lua_GatherSoulItem");
checkRequire("Lua_GatherSoulPackCellsItem");
Lua_GatherSoulPanel = class("Lua_GatherSoulPanel", Lua_DisplayObject);
function Lua_GatherSoulPanel:ctor(p)
	self:superCall("ctor", p, "GatherSoulPanel_skin");
end

function Lua_GatherSoulPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.soulDust = DataCenter.gatherSoulUtil.soul_dust;
	self.soulStone = DataCenter.gatherSoulUtil.soul_stone;

	self.soulIcon1:setAltas("item6", tostring(self.soulDust));
	self.soulIcon1:SetDimensions(50, 50);
	self.soulIcon1:addClickFuntion(self, self.onOpenSoulDustTips);

	self.soulIcon2:setAltas("item6", tostring(self.soulStone));
	self.soulIcon2:SetDimensions(50, 50);
	self.soulIcon2:addClickFuntion(self, self.onOpenSoulStoneTips);

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 463, 537));
	self.dragList:setLocation(265, 6, 0);
	self.dragList:setListCell(Lua_GatherSoulPackCellsItem, 92, 92, 5);

	self.readPowerBtn:addClickFuntion(self, self.onAddPropertyClick); -- 属性加成
	self.gatherButton:addClickFuntion(self, self.onSoulGatherClick); -- 灵魂凝聚
	self.resolveButton:addClickFuntion(self, self.onSoulResolveClick); -- 灵魂分解

	local poses = {{-304, 160}, {-167, 80}, {-167, -75}, {-304, -154}, {-442, -75}, {-442, 80}, {-304.5, 2.5}};
	local item;
	self.itemArr = Array();
	for i, v in ipairs(poses) do
		item = Lua_GatherSoulItem.new(self.content);
		item:setLocation(v[1], v[2], 0);
		item:setDepth(5);
		item:setCanClick(true);
		item:setSoulNnmetype(i);
		self.itemArr:add(item);
	end

	Lua_ProxyManager.getProxy("Lua_GatherSoulProxy"):sOpenGatherSouPanel();
	self:addLuaEvent("rOpenGatherSoulPanelInfo", self, self.openGatherSouPanel);  -- 打开灵魂面板
	self:addLuaEvent("PACK_GATHERSOUL_UPDATE", self, self.openGatherSouPanel);    -- 背包获取新灵魂后刷新灵魂界面
end

function Lua_GatherSoulPanel:openGatherSouPanel()
	self.property = DataCenter.gatherSoulUtil.gatherSoulConfigInfo;
	self.soulLab1.text =  DataCenter.gatherSoulData.soulDust; -- 粉尘
	self.soulLab2.text =  DataCenter.gatherSoulData.soulStone; -- 魂石

	local data = DataCenter.gatherSoulData.soulHolesInfo;
	for k,v in pairs(data) do
		if v.id ~= nil then
			self.itemArr[v.id + 1]:setSoultype(v);
		end
	end

	self:onUpdatePackItemInfo();
	self:updateIsShowRed();
end

function Lua_GatherSoulPanel:onUpdatePackItemInfo()
	local packArry = Array()
	local len = DataCenter.gatherSoulUtil.pkg_size;

	local bagData = DataCenter.packData:getBagType(Lua_PackData.JH_PACK);--聚魂
	local arr = bagData:getBagAllData();
	for i = 1, arr:getSize() do
		for j = i + 1, arr:getSize() do
			if not DataCenter.gatherSoulData:sortPackFun(arr[i], arr[j]) then
				local temp = arr[i]
				arr[i] = arr[j]
				arr[j] = temp
			end
		end
	end

	local list;
	for i = 1, len do
		list = {};
		if arr[i] ~= nil then 
			list.data = arr[i]; 
		end
		packArry:add(list)
	end
	self.dragList:setLuaArrayData(packArry, false);
	self:updateIsShowRed();
end

-- 红点更新
function Lua_GatherSoulPanel:updateIsShowRed()
	local isShowCohesionRed = DataCenter.gatherSoulData:isShowCohesionRed(); -- 凝聚
	self:showCohesionRedDot(isShowCohesionRed);

	local isShowResolveRed = DataCenter.gatherSoulData:isShowSoulResolveRed(); -- 分解
	self:showResolveRedDot(isShowResolveRed);
end

-- 聚魂红点
function Lua_GatherSoulPanel:showCohesionRedDot(val)
	if val then
		if self._redDotIcon1 == nil then
			self._redDotIcon1 = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 239, -289, 0, 0);
			self._redDotIcon1:setDepth(7);
			self._redDotIcon1.name = "redDotIcon1";
		end
		self._redDotIcon1:setEnable(true);
	else
		if self._redDotIcon1 ~= nil then
			self._redDotIcon1:setEnable(false);
		end
	end
end

-- 分解红点
function Lua_GatherSoulPanel:showResolveRedDot(val)
	if val then
		if self._redDotIcon2 == nil then
			self._redDotIcon2 = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 475, -289, 0, 0);
			self._redDotIcon2:setDepth(7);
			self._redDotIcon2.name = "redDotIcon2";
		end
		self._redDotIcon2:setEnable(true);
	else
		if self._redDotIcon2 ~= nil then
			self._redDotIcon2:setEnable(false);
		end
	end
end

-- 粉尘Tips
function Lua_GatherSoulPanel:onOpenSoulDustTips()
	Lua_PackUtil.showItemInfo(Lua_ToolVo.new(self.soulDust), false)
end

-- 魂石Tips
function Lua_GatherSoulPanel:onOpenSoulStoneTips()
	Lua_PackUtil.showItemInfo(Lua_ToolVo.new(self.soulStone), false)
end

function Lua_GatherSoulPanel:onAddPropertyClick()
	Lua_WindowUtil.openWin("Lua_GatherSoulPropertyWindow");
end

function Lua_GatherSoulPanel:onSoulGatherClick()
	Lua_WindowUtil.openWin("Lua_SoulCohesionWindow");
end

function Lua_GatherSoulPanel:onSoulResolveClick()
	Lua_WindowUtil.openWin("Lua_GatherSoulResolveWindow");
end

function Lua_GatherSoulPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self._redDotIcon1 ~= nil then
		self._redDotIcon1:dispose();
		self._redDotIcon1 = nil;
	end
	if self._redDotIcon2 ~= nil then
		self._redDotIcon2:dispose();
		self._redDotIcon2 = nil;
	end

	self:superCall("dispose");
end