-- 凝聚Panel
Lua_SoulCohesionPanel = class("Lua_SoulCohesionPanel", Lua_DisplayObject);
function Lua_SoulCohesionPanel:ctor(p)	
	self:superCall("ctor", p, "SoulCohesionPanel_skin");
end

function Lua_SoulCohesionPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.leftImage = Lua_ToolImage.new(self.showObj1);
	self.leftImage:setDepth(5);

	self.centerImage = Lua_ToolImage.new(self.content);
	self.centerImage:setDepth(5);
	self.centerImage:setLocation(133.5, 47.5, 0);

	local tImg;
	self.materlsArr = Array();
	for i = 1, 2 do
		tImg = Lua_ToolImage.new(self["showObj" .. i + 1]);
		tImg:setDepth(5);
		self.materlsArr:add(tImg);
	end
	self.cohesionBtn:addClickFuntion(self, self.onCohesionClick);
end

function Lua_SoulCohesionPanel:setData(val)	
	self.data = val;

	local arr = val.cost_item;
	local max_soul_arr = nil;
	local soulLevel = 0;
	if arr ~= nil then
		soulLevel = DataCenter.gatherSoulData:getSoulLevel(val.id,arr[1][1],arr[2][1]);
	end

	local soul_stone_id = DataCenter.gatherSoulUtil.soul_stone;
	self.soul_stone_num = DataCenter.gatherSoulData.soulStone;
	
	local tvo = Lua_ToolVo.createToolVo(val.id);
	tvo.bShowItemBg = true;
	tvo.soul_level = soulLevel;
	tvo.isShowBtn = false;

	self.leftImage.data = Lua_ToolVo.createToolVo(soul_stone_id);
	self.leftImage:showNumLimit(self.soul_stone_num,val.cost_soul_stone,2)
	self.leftImage.num_txt.pivot = UIWidget.Pivot.Center;
	self.leftImage.num_txt:setLocation(0,-23,0);
	self.leftImage.num_txt.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.name1.text = DataCenter.gatherSoulUtil.soul_stone_name;

	self.centerImage.data = tvo;
	self.ylName.text = tvo.soulName;
	self.ylProp.text = tvo.soulCohesionProp;
	self.successTxt.text = LanUtil.formateStr(LanUtil.getValue(124429),tostring(val.probability));
	if DataCenter.roleData.level >= val.level then
		self.needLvlTxt.text = LanUtil.formateStr(LanUtil.getValue(124450),tostring(val.level));
	else
		self.needLvlTxt.text = LanUtil.formateStr(LanUtil.getValue(124430),tostring(val.level));
	end

	if arr ~= nil  then
		local len = #arr;
		local soul_level;
		for i = 1, len do
			local bagNum = DataCenter.packData:getBagType(Lua_PackData.JH_PACK):getItemNum(arr[i][1]);
			local maxSoulArr = DataCenter.gatherSoulData:getMaxSoulLvlArray(arr[i][1]);
			if maxSoulArr == nil or maxSoulArr:getSize() == 0 then
				soul_level = 0;
			else
				soul_level = maxSoulArr[1].soul_level;
			end 
			local tvo = Lua_ToolVo.createToolVo(arr[i][1])
			tvo.bShowItemBg = true;
			tvo.soul_level = soul_level;
			tvo.isShowBtn = false;
			self.materlsArr[i].data = tvo;
			self.materlsArr[i]:showNumLimit(bagNum,arr[i][2],2)
			self.materlsArr[i]:showLockSlot(false);
		end

		local tvo1 = Lua_ToolVo.createToolVo(arr[1][1]);
		local tvo2 = Lua_ToolVo.createToolVo(arr[2][1]);
		self.name2:setEnable(true);
		self.name3:setEnable(true);
		self.name2.text = tvo1.soulName;
		self.name3.text = tvo2.soulName;
	else
		for i = 1, self.materlsArr:getSize() do
			self.materlsArr[i].data = nil;
			self.materlsArr[i]:showLockSlot(true);
		end
		self.name2:setEnable(false);
		self.name3:setEnable(false);
	end
	self:updateIsShowRed();
end

-- 凝聚
function Lua_SoulCohesionPanel:onCohesionClick()
	if self.data.level <= DataCenter.roleData.level then
		local arr = self.data.cost_item;
		if arr ~= nil then
			local bagNum1 = DataCenter.packData:getBagType(Lua_PackData.JH_PACK):getItemNum(arr[1][1]);
			local bagNum2 = DataCenter.packData:getBagType(Lua_PackData.JH_PACK):getItemNum(arr[2][1]);
			local needNum1 = arr[1][2];
			local needNum2 = arr[2][2];
			if self.soul_stone_num >= self.data.cost_soul_stone and bagNum1 >= needNum1 and bagNum2 >= needNum2 then
				local doubleArray = DataCenter.gatherSoulData:getSoulDoubleArray(arr);
		        Lua_ProxyManager.getProxy("Lua_GatherSoulProxy"):sCohesionSoul(self.data.id,doubleArray);
			else
				OperateAlert.show(LanUtil.getValue(124432));
			end
		else
			if self.soul_stone_num >= self.data.cost_soul_stone then
				Lua_ProxyManager.getProxy("Lua_GatherSoulProxy"):sCohesionSoul(self.data.id);
			else
				OperateAlert.show(LanUtil.getValue(124432));
			end
		end
	else
		OperateAlert.show(LanUtil.getValue(124431));
	end
end

function Lua_SoulCohesionPanel:updateIsShowRed()
	if self.data.level <= DataCenter.roleData.level then
		local arr = self.data.cost_item;
		if arr ~= nil then
			local bagNum1 = DataCenter.packData:getBagType(Lua_PackData.JH_PACK):getItemNum(arr[1][1]);
			local bagNum2 = DataCenter.packData:getBagType(Lua_PackData.JH_PACK):getItemNum(arr[2][1]);
			local needNum1 = arr[1][2];
			local needNum2 = arr[2][2];
			self:showRedDot(self.soul_stone_num >= self.data.cost_soul_stone and bagNum1 >= needNum1 and bagNum2 >= needNum2);
		else
			self:showRedDot(self.soul_stone_num >= self.data.cost_soul_stone);
		end
	else
		self:showRedDot(false);
	end
end

function Lua_SoulCohesionPanel:showRedDot(val)
	if val then
		if self.redDot == nil then
			self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 178, -207, 0, 0);
			self.redDot.name = "redDot";
			self.redDot:setDepth(10);
		end
		self.redDot:setEnable(true);
	else
		if self.redDot ~= nil then
			self.redDot:setEnable(false);
		end
	end
end

function Lua_SoulCohesionPanel:dispose()
	if self.leftImage ~= nil then
		self.leftImage:dispose();
		self.leftImage = nil;
	end
	if self.centerImage ~= nil then
		self.centerImage:dispose();
		self.centerImage = nil;
	end
	if self.materlsArr ~= nil then
		self.materlsArr:dispose();
		self.materlsArr:clear();
		self.materlsArr = nil;
	end
	if self.redDot ~= nil then
		self.redDot:dispose();
		self.redDot = nil;
	end

	self:superCall("dispose");
end