-- 灵魂聚集
checkRequire("Lua_SoulCohesionPanel");
Lua_SoulCohesionWindow = class("Lua_SoulCohesionWindow", Lua_SecondSizeWindow)
function Lua_SoulCohesionWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_SoulCohesionWindow";
	self.skinName = "SoulCohesionWindow_skin";
	self.titleText = LanUtil.getValue(124401);
end

function Lua_SoulCohesionWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.soulCohesionPanle = Lua_SoulCohesionPanel.new(self.content);

	local arr = DataCenter.gatherSoulUtil.getGatherCalssInfo;
	self.btnList = Lua_DragSubButtonList.new(self.content, 1, Vector4(0, 0, 212, 520),
		Vector3(212, 66, 0), Vector3(186, 48, 0), Vector2(0, 0), Vector3(0, 16));
	self.btnList:setDepth(5);
	self.btnList:setMainBtnStyle("common_atlas_1", "ui_common_btn_p2", "ui_common_btn_p1", "D5DADE", "FFFFFF", 30);
	self.btnList:setSubBtnStyle("common_atlas_1", "ui_common_btn_p4", "ui_common_btn_p3", "FFFFFF", "FFFCB7", 26); -- "92A0DA"
	self.btnList:setLocation(-432, -31, 0);
	self.btnList:setData(arr, self, self.onButtonListClick, 0, 227); -- (520 - 66) / 2
	self.btnList:setMainSlected(1, 1);
	self.btnList.clickDrawBack = true;

	self.helpLab.text = LanUtil.getValue(124410);
	self.help:addClickFuntion(self,self.onHelp);

	self:updateShowRodDataList();
	
	self:addLuaEvent("rOpenGatherSoulPanelInfo", self, self.onItemChange);
	self:addLuaEvent("rCohesionSoulInfo", self, self.onUpdateEffect);
end

function Lua_SoulCohesionWindow:showWin(param)
	self:superCall("showWin", param);

	local costId;
	local index;
	local group_index;
	if param.isTips == false then -- 凝聚按钮
		costId = DataCenter.gatherSoulUtil:getSoulCostId(param.vo.id);
		index = DataCenter.gatherSoulUtil:getSoulCalssId(costId);
		group_index = DataCenter.gatherSoulUtil:getSoulGroupIndex(costId, index)
	else -- 产出点击
		index = DataCenter.gatherSoulUtil:getSoulCalssId(param.vo.id);
		group_index = DataCenter.gatherSoulUtil:getSoulGroupIndex(param.vo.id, index);
	end
	self.btnList:setMainSlected(index, group_index, false);
end 

function Lua_SoulCohesionWindow:onItemChange()
	if self.selectedData.data ~= nil then
		self.soulCohesionPanle:setData(self.selectedData.data);
		self:updateShowRodDataList();
	end
end

function Lua_SoulCohesionWindow:onButtonListClick(data)
	self.selectedData = data;
	self.soulCohesionPanle:setData(data.data);
	self:updateWindowDepth();
	self:updateShowRodDataList();
end

function Lua_SoulCohesionWindow:updateShowRodDataList()
	local info = DataCenter.gatherSoulUtil.gatherCalssInfo;
	local list;
	local redList = {};
	for k,v in pairs(info) do
		list = DataCenter.gatherSoulUtil:updateShowRedList(k);
		for i,j in pairs(list) do
			redList[k] = j;
		end
	end
	self.btnList:setRedDot(1, redList);
	self:updateShowRed()
end

function Lua_SoulCohesionWindow:updateShowRed()
	if self.selectedData == nil then
		return;
	end

	local info = DataCenter.gatherSoulUtil.gatherCalssInfo;
	local list;
	local redList = {};
	for k,v in pairs(info) do
		list = DataCenter.gatherSoulUtil:getShowCohesionRedList(k);
		if v.soul_group_list ~= nil then
			redList[k] = {};
			for i,j in pairs(v.soul_group_list) do
				redList[k][i] = list[j];
			end
		end
	end
	self.btnList:setRedDot(2, redList[self.selectedData.mainIndex]);
end

-- 1成功，0失败
function Lua_SoulCohesionWindow:onUpdateEffect(state)
	if self.rsEffect ~= nil then
		self.rsEffect:dispose();
		self.rsEffect = nil;
	end

	if state == 1 then
		self.rsEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_ningjuchenggong", "gui_ningjuchenggong", 117, 15);
	else
		self.rsEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_ningjushibai", "gui_ningjushibai", 0, 0);
	end
	self.rsEffect:SetRenderQueue(self.help, 100, 2, false);
end

function Lua_SoulCohesionWindow:onHelp()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(124411));
end

function Lua_SoulCohesionWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.rsEffect ~= nil then
		self.rsEffect:dispose();
		self.rsEffect = nil;
	end

	self:superCall("dispose");
end