-- 灵魂升级
Lua_SoulUpgradeWindow  = class("Lua_SoulUpgradeWindow", Lua_Window);
function Lua_SoulUpgradeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_SoulUpgradeWindow";
	self.skinName = "SoulUpgradeWindow_skin";
end

function Lua_SoulUpgradeWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImage = Lua_ToolImage.new(self.content);
	self.itemImage:setLocation(0, 41, 0)
	self.itemImage:setDepth(10);

	self.upgradeBtn:addClickFuntion(self, self.onUpgradeBtnClick);

	self:addLuaEvent("rOpenGatherSoulPanelInfo", self, self.showSoulUpgradeInfo);
	self:showSoulUpgradeInfo();
end

function Lua_SoulUpgradeWindow:showSoulUpgradeInfo()
	local grooveId = DataCenter.gatherSoulData.openGrooveId;
	self.data = DataCenter.gatherSoulData:getArrByGrooveId(grooveId);
	self.vo = self.data.soulVo;
	self.vo.isShowUpgrade = true; -- 升级属性标识位
	self.itemImage.data = self.vo;
	self.nameTxt.text = self.vo.soulUpgradeName;

	local isMsxLvl = DataCenter.gatherSoulUtil:isMsxLvl(self.vo.soulColor, self.data.soulLv); -- 是否满级
	self.upgradeDust = self.vo.soulUpgrade; -- 升级需要的灵魂粉尘
	self.soulDust = DataCenter.gatherSoulData.soulDust; -- 身上的灵魂粉尘
	if isMsxLvl == false then -- 没满级
		self.propTxt.text = self.vo.soulProp;
		self.addPropTxt.text = self.vo.soulNextProp;
		if self.soulDust >= self.upgradeDust then
			self.updateTxt.text = LanUtil.formateStr(LanUtil.getValue(124404), tostring(self.soulDust), tostring(self.upgradeDust));
		else
			self.updateTxt.text = LanUtil.formateStr(LanUtil.getValue(124414), tostring(self.soulDust), tostring(self.upgradeDust));
		end
		self.spr2:setEnable(self.vo.prop_type ~= 1);
	else
		self.propTxt.text = self.vo.soulProp;
		self.updateTxt.text = LanUtil.getValue(121525);
		self.updateTxt:setLocation(-self.updateTxt.width / 2, -110, 0);
	end
	self.spr:SetActive(not isMsxLvl);
	self.addPropTxt:setEnable(not isMsxLvl);
	self.updateLab:setEnable(not isMsxLvl);
	self.itemIcon:setEnable(not isMsxLvl);
	self.upgradeBtn:setEnable(not isMsxLvl);
	self:showRedDot(isMsxLvl == false and self.soulDust >= self.upgradeDust);
end

-- 属性加成
function Lua_SoulUpgradeWindow:onUpgradeBtnClick()
	if self.soulDust >= self.upgradeDust then
		Lua_ProxyManager.getProxy("Lua_GatherSoulProxy"):sUpgradeSoul(self.data.id)
	else
		OperateAlert.show(LanUtil.getValue(124415))
	end
end

function Lua_SoulUpgradeWindow:showRedDot(val)--红点显示
	if val then
		if self._redDot == nil then
			self._redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 94, -143, 0, 0);
			self._redDot.name = "redDot";
			self._redDot:setDepth(7);
		end
		self._redDot:setEnable(true);
	else
		if self._redDot ~= nil then
			self._redDot:setEnable(false);
		end
	end
end

function Lua_SoulUpgradeWindow:dispose()
	if self.itemImage ~= nil then
		self.itemImage:dispose();
		self.itemImage = nil;
	end
	if self._redDot ~= nil then
		self._redDot:dispose();
		self._redDot = nil;
	end
	self:superCall("dispose");
end