-- 聚魂item
Lua_GatherSoulItem = class("Lua_GatherSoulItem", Lua_DisplayObject);
function Lua_GatherSoulItem:ctor(p)
	self:superCall("ctor", p, "GatherSoulItem_skin");
end

function Lua_GatherSoulItem:buildShowItem()
	self:superCall("buildShowItem");

	self.bg:addLoadCompleteFun(self, self.onLoadCompleteImg1);
	self.soulSp:addLoadCompleteFun(self, self.onLoadCompleteImg2);
end

function Lua_GatherSoulItem:onLoadCompleteImg1()
	self.bg:resetSize();
end

function Lua_GatherSoulItem:onLoadCompleteImg2()
	self.soulSp:resetSize();
end

function Lua_GatherSoulItem:setSoulNnmetype(val)
	self.soulType = val;
	self.content.name = "Lua_GatherSoulItem"..val;
end

function Lua_GatherSoulItem:setSoultype(data)
	self.data = data;

	if data.unLock == true then
		if data.soulId ~= nil and data.soulId ~= 0 then
			self.soul_lvl:setEnable(true);
			self.soul_name:setEnable(true);
			self.soul_Lab:setEnable(false);
			self.soul_lvl.text = data.soulVo.soulLv;
			self.soul_name.text = data.soulVo.soulName;

			self:setShowSoulBg(data.soulId, true, data.id);
			self:setShowSoul(true, data.soulId);
			local isMsxLvl = DataCenter.gatherSoulUtil:isMsxLvl(data.soulVo.soulColor, data.soulVo.soul_level); -- 是否满级 
			if isMsxLvl == false then
				self:showRedDot(data.soulVo.soulUpgrade ~= nil and DataCenter.gatherSoulData.soulDust >= data.soulVo.soulUpgrade);--红点
			else
				self:showRedDot(false);
			end
		elseif data.soulId ~= nil and data.soulId == 0 then
			self.soul_lvl:setEnable(false);
			self.soul_name:setEnable(false);
			self.soul_Lab:setEnable(false);

			self:setShowSoulBg(data.soulId,true,data.id);
			self:setShowSoul(false);
			self:showRedDot(data.isShowSoulDressRed);
		end
	else
		self.soul_lvl:setEnable(false);
		self.soul_name:setEnable(false);
		self.soul_Lab:setEnable(true);
		if DataCenter.gatherSoulUtil:lvl_unlock(data.id) ~= nil then
			self.soul_Lab.text = LanUtil.formateStr(LanUtil.getValue(124412), tostring(DataCenter.gatherSoulUtil:lvl_unlock(data.id)));
		else
			self.soul_Lab.text = LanUtil.formateStr(LanUtil.getValue(124413), tostring(DataCenter.gatherSoulUtil:prof_lvl(data.id)));
		end

		self:setShowSoulBg(data.soulId, false, data.id);
		self:setShowSoul(false);
		self:showRedDot(false);
	end
end

-- 灵魂背景添加点击方法
function Lua_GatherSoulItem:setCanClick(val)
	if val then
		self.soul_icon.mouseEnable = true;
		self.soul_icon:addClickFuntion(self, self.onSoulIconClick);
	else
		self.soul_icon.mouseEnable = false;
		self.soul_icon:removeClickFuntion(self, self.onSoulIconClick);
	end
end

-- 灵魂背景显示
function Lua_GatherSoulItem:setShowSoulBg(soulId, val, holeId)
	if soulId ~= nil and soulId == 0 then
		self.soulSp:setEnable(true);
		if val then
			if holeId <= 5 then
				self.bg:setAltas("minghun_atlas", "ui_minghun_icon_3");
				self.soulSp:setAltas("minghun_atlas", "ui_minghun_z_3");
			else
				self.bg:setAltas("minghun_atlas", "ui_minghun_icon_5");
				self.soulSp:setAltas("minghun_atlas", "ui_minghun_z_2");
			end
		else
			if holeId <= 5 then
				self.bg:setAltas("minghun_atlas", "ui_minghun_icon_4");
				self.soulSp:setAltas("minghun_atlas", "ui_minghun_z_4");
			else
				self.bg:setAltas("minghun_atlas", "ui_minghun_icon_6");
				self.soulSp:setAltas("minghun_atlas", "ui_minghun_z_5");
			end
		end
	elseif soulId ~= nil and soulId ~= 0 then
		self.soulSp:setEnable(false);
		if holeId <= 5 then
			self.bg:setAltas("minghun_atlas", "ui_minghun_icon_3");
		else
			self.bg:setAltas("minghun_atlas", "ui_minghun_icon_5");
		end
	end
end

-- 灵魂显示
function Lua_GatherSoulItem:setShowSoul(val, id)
	if id ~= nil then
		self.soul_icon:setAltas("item23", tostring(id));
	end
	self.soul_icon:setEnable(val);
end

function Lua_GatherSoulItem:setDepth(val)
	self:superCall("setDepth", val);

	self.bg:setDepth(val);
	self.soulSp:setDepth(val + 1);
	self.soul_icon:setDepth(val + 2);
	self.soul_lvl:setDepth(val + 3);
	self.soul_name:setDepth(val + 3);
	self.soul_Lab:setDepth(val + 3);
end

function Lua_GatherSoulItem:showRedDot(val)
	if val then
		if self.redDot == nil then
			self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 30, 30, 0, 0);
			self.redDot.name = "redDot";
			self.redDot:setDepth(10);
		end
		self.redDot:setEnable(true);
	else
		if self.redDot ~= nil then
			self.redDot:setEnable(false);
		end
	end
end

function Lua_GatherSoulItem:onSoulIconClick(go)
	DataCenter.gatherSoulData.openGrooveId = self.data.id;
	Lua_PackUtil.showItemInfo(self.data.soulVo, false, nil, true);
end

function Lua_GatherSoulItem:dispose()
	if self.redDot ~= nil then
		self.redDot:dispose();
		self.redDot = nil;
	end

	self:superCall("dispose");
end