-- 聚魂背包Item
Lua_GatherSoulPackCellsItem = class("Lua_GatherSoulPackCellsItem", Lua_ListCell);
function Lua_GatherSoulPackCellsItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_GatherSoulPackCellsItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImage = Lua_ToolImage.new(self.content);
	self.itemImage:setDepth(3);
	self.itemImage:setCanClick(false);
end

function Lua_GatherSoulPackCellsItem:setData(data)
	self.data = data.data;

	if self.data ~= nil then
		self.itemImage.data = self.data;
		self.itemImage:showItemLvl(data.data.soulLv);
		self.itemImage:showRoundEff(true);
		if self.data.color >= 3 then
			self.itemImage.roundEff:setSacle(0.95, 0.95, 0.95);
		end

		self.itemImage:showRedDot(self.data.isShowDressRed);
	else
		self.itemImage.data = nil;
		self.itemImage:showItemLvl(nil);
		self.itemImage:showRoundEff(false);
		self.itemImage:showRedDot(false);
	end
end

function Lua_GatherSoulPackCellsItem:checkOutBound(showRect)
	if self.data == nil then
		return;
	end

	local width = self.itemImage.item_bg.width;
	local height = self.itemImage.item_bg.height;
	local rect = Lua_Rectangle.new(self.itemX - width / 2, self.itemY - height / 2, width, height);
	self.itemImage:showRoundEff(showRect:containeRect(rect) and self.data.color >= 3);
end

function Lua_GatherSoulPackCellsItem:onPlayerSoundClick(go)
	if self.data ~= nil then
		Lua_PackUtil.showItemInfo(self.data, false, nil, true);
	end
end

function Lua_GatherSoulPackCellsItem:dispose()
	if self.itemImage ~= nil then
		self.itemImage:dispose();
		self.itemImage = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end