-- 灵纹界面
checkRequire("Lua_RunePanel"); -- 灵纹信息
checkRequire("Lua_RuneResolvePanel"); -- 灵纹分解 
checkRequire("Lua_RuneExchangePanel"); -- 灵纹兑换
checkRequire("Lua_RuneCompoundPanel"); -- 灵纹合成
Lua_RuneAllPanel = class("Lua_RuneAllPanel", Lua_DisplayObject);
function Lua_RuneAllPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_RuneAllPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.btnNames = Array();
	self.btnNames:add({name = LanUtil.getValue(121538), panel = Lua_RunePanel, eventIds = {11175}});
	self.btnNames:add({name = LanUtil.getValue(121507), panel = Lua_RuneResolvePanel, eventIds = {22033}});
	self.btnNames:add({name = LanUtil.getValue(121502), panel = Lua_RuneExchangePanel});
	self.btnNames:add({name = LanUtil.getValue(121529), panel = Lua_RuneCompoundPanel, eventIds = {22034}, openId = 10157});

	self.runeList = Lua_ButtonList.new(self.content, self.btnNames, 164, self, self.onButtonListClick,
		"ui_common_btn_c2", "ui_common_btn_c1", Vector4(0, 0, 148, 66), Vector4(0, 0, 148, 66),
		Lua_ColorDefine.transColor("D2D8DC"), Lua_ColorDefine.transColor("FFFFFF"), Vector4(28, 28, 120, 30), 2, "common_atlas_1");
	self.runeList:setDepth(5);
	self.runeList:setRedDotPos(63, 23);
	self.runeList:setLocation(-540, 250, 0);

	local isShowIcon;
	for i = 1, self.btnNames:getSize() do
		isShowIcon = true;
		if self.btnNames[i].openId == nil or DataCenter.runeData.isOpenCompound == true then
			self.runeList:setBtnGray(false, i, isShowIcon)
		else
			local cfg = getConfig({"func_open", self.btnNames[i].openId});
			if cfg ~= nil and cfg.advance_function ~= nil then
				isShowIcon = cfg.advance_function == 1
			end
			self.runeList:setBtnGray(true, i, isShowIcon);
		end
	end

	self:addLuaEvent("rOpenRunePanelInfo", self, self.onUpdateRuneInfo);
	Lua_ProxyManager.getProxy("Lua_RuneProxy"):sOpenRunePanelInfo();
end

function Lua_RuneAllPanel:onButtonListClick(val)
	-- 灵纹合成特殊处理
	if self.btnNames[val].openId ~= nil and DataCenter.runeData.isOpenCompound == false then
		local tipsInfo = getConfig({"func_open", 10157, "advance_message"});
		if tipsInfo ~= nil then
			OperateAlert.show(tipsInfo);
		end
		return;
	end

	if self.selectIndex ~= val then
		if self.curPanel ~= nil then
			self.curPanel:dispose();
			self.curPanel = nil;
		end
		self.curPanel = self.btnNames[val].panel.new(self.content);
	end
	self.selectIndex = val;
end

function Lua_RuneAllPanel:onUpdateRuneInfo()
	local selectIndex = self.selectIndex == nil and DataCenter.runeData.selectIndex or self.selectIndex;
	self.runeList:setSelected(selectIndex, true);
end

function Lua_RuneAllPanel:dispose()
	if self.btnNames ~= nil then
		self.btnNames:dispose();
		self.btnNames:clear();
		self.btnNames = nil;
	end
	if self.runeList ~= nil then
		self.runeList:dispose();
		self.runeList = nil;
	end
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end

	self:superCall("dispose");
end