-- 灵纹总览
checkRequire("Lua_RuneShowItem");
Lua_RuneAllShowWindow = class("Lua_RuneAllShowWindow", Lua_ThirdSizeWindow)
function Lua_RuneAllShowWindow:ctor()
    self:superCall("ctor", true, 3500, true, LanUtil.getValue(121512));

    self.windowName = "Lua_RuneAllShowWindow";
    self.w = 605;
    self.h = 661;
end

function Lua_RuneAllShowWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.bordBg = UICreate.createUIAtlasImage(self.content, "common_atlas_2", "ui_common_widget_m1", 0, -25, 581, 583);
    self.bordBg.name = "bordBg";
	self.bordBg:setDepth(1);

    self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, -290, 580, 580));
    self.dragContainer:setLocation(0, 265, 0);

	local list = DataCenter.runeUtil.preview_rune;
    local item;
    for i = 1, list:getSize() do
    	item = Lua_RuneAllShowItem.new(self.dragContainer.content);
    	item:setData(list[i]);
    	self.dragContainer:addSubContainer(item, false);
    end
    self.dragContainer:updateChildPos();
end

function Lua_RuneAllShowWindow:dispose()
	if self.bordBg ~= nil then
		self.bordBg:dispose();
		self.bordBg = nil;
	end
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_RuneAllShowItem = class("Lua_RuneAllShowItem", Lua_DragContainerItem);
function Lua_RuneAllShowItem:ctor(p)
	self:superCall("ctor", p, nil);
end

function Lua_RuneAllShowItem:buildShowItem()
	self:superCall("Lua_RuneAllShowItem");

	self._height = 55;
	self.itemArr = Array();

	self.titleBg = UICreate.createUIAtlasImage(self.content, "common_atlas_2", "ui_common_title_05", 0, 0, 0, 0);
	self.titleBg.name = "titleBg";
	self.titleBg.pivot = UIWidget.Pivot.Top;
	self.titleBg:setDepth(2);

	self.titleTxt = UICreate.createLabel(self.content, "", 0, -15, 250, 30, 26);
	self.titleTxt.name = "titleTxt";
	self.titleTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.titleTxt.pivot = UIWidget.Pivot.Top;
	self.titleTxt:setDepth(3);
end

function Lua_RuneAllShowItem:setData(data)
	self.data = data;
	local len = data:getSize();
	if len > 0 then
		self.titleTxt.text = data[1].unlock_condition;
		for i = 1, len do
			local list = data[i].list;
			for j = 1, #list do
				local item = Lua_RuneShowItem.new(self.content);
				local vo = Lua_ToolVo.createToolVo(tonumber(list[j]));
				vo.rune_level = 1;
				item:setData(vo);
				item:setLocation((j - 1) * 136 - 204, (i - 1) * -100 - 100, 0);
				self.itemArr:add(item);
			end
		end
	end
	self._height = len > 0 and 80 + len * 100 or 80;
end

function Lua_RuneAllShowItem:getHeight()
	return self._height;
end

function Lua_RuneAllShowItem:onPlayerSoundClick()
  	local v = Vector3(UnityEngine.Input.mousePosition.x, UnityEngine.Input.mousePosition.y, 0);
    local screenpos = UICamera.mainCamera:ScreenToWorldPoint(v);
    local mousePosition = self.content.transform:InverseTransformPoint(screenpos);
    local len = self.itemArr:getSize();
    for i = 1, len do
    	if self.itemArr[i]:checkMouseClick(mousePosition) == true then
    		self.itemArr[i]:showItemTip();
    		return;
    	end
    end
end

function Lua_RuneAllShowItem:dispose()
	if self.itemArr ~= nil then
		local len = self.itemArr:getSize();
		for i = 1, len do 
			self.itemArr[i]:dispose();
		end
		self.itemArr:clear();
		self.itemArr = nil;
	end

    self:superCall("dispose");
end