checkRequire("Lua_RuneCompoundSubPanel");
Lua_RuneCompoundPanel = class("Lua_RuneCompoundPanel", Lua_DisplayObject);
function Lua_RuneCompoundPanel:ctor(p)
	self:superCall("ctor", p, "RuneCompoundWindow_skin");
end

function Lua_RuneCompoundPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.runeCompoundPanel = Lua_RuneCompoundSubPanel.new(self.content);

	local arr = DataCenter.runeUtil.getCompoundCalssInfo;
	self.btnList = Lua_DragSubButtonList.new(self.content, 1, Vector4(0, 0, 212, 520),
		Vector3(212, 66, 0), Vector3(186, 48, 0), Vector2(0, 0), Vector3(0, 16));
	self.btnList:setDepth(5);
	self.btnList:setMainBtnStyle("common_atlas_1", "ui_common_btn_p2", "ui_common_btn_p1", "D5DADE", "FFFFFF", 30);
	self.btnList:setSubBtnStyle("common_atlas_1", "ui_common_btn_p4", "ui_common_btn_p3", "FFFFFF", "FFFCB7", 26); -- "92A0DA"
	self.btnList:setLocation(-483, -68, 0);
	self.btnList:setData(arr, self, self.onButtonListClick, 0, 227); -- (520 - 66) / 2
	self.btnList:setMainSlected(1, 1);
	self.btnList.clickDrawBack = true;

	self.helpLab.text = LanUtil.getValue(121530);
	self.help:addClickFuntion(self, self.onHelpClick);

	self:updateShowRodDataList();
	
	self:addLuaEvent("rOpenRunePanelInfo", self, self.onUpdateItemChange);
	self:addLuaEvent("IS_SUCCEED_STATE", self, self.onUpdateEffect);
end

function Lua_RuneCompoundPanel:showWin(param)
	self:superCall("showWin", param);

	if type(self.showData) == "table" then
		local index = DataCenter.gatherSoulUtil:getCompoundCalssId(self.showData.data.id);
		local group_index = DataCenter.gatherSoulUtil:getCompoundGroupIndex(self.showData.data.id,index);
		self.btnList:setMainSlected(index, group_index,false);
	elseif type(self.showData) == "number" then
		self.btnList:setMainSlected(self.showData, self.showData,false);
	end
end

function Lua_RuneCompoundPanel:onButtonListClick(data)
	self.selectedData = data;
	if data.isShowLock == true then
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(121537),tostring(data.data.runetower_limit)));
		return;
	end
	self.runeCompoundPanel:setData(data.data);
	self:updateShowRodDataList();
end

function Lua_RuneCompoundPanel:updateShowRodDataList()
	local info = DataCenter.runeUtil.getCalssConfigInfo;
	local list;
	local redList = {};
	for k,v in pairs(info) do
		list = DataCenter.runeUtil:updateShowRedList(k);
		for i,j in pairs(list) do
			redList[k] = j;
		end
	end
	self.btnList:setRedDot(1, redList);
	self:updateShowRed()
end

function Lua_RuneCompoundPanel:updateShowRed()
	if self.selectedData == nil then
		return;
	end

	local info = DataCenter.runeUtil.getCalssConfigInfo;
	local list;
	local redList = {};
	for k,v in pairs(info) do
		list = DataCenter.runeUtil:getShowCompoundRedList(k);
		if v.rune_group_list ~= nil then
			redList[k] = {};
			for i, j in pairs(v.rune_group_list) do
				redList[k][i] = list[j];
			end
		end
	end
	self.btnList:setRedDot(2, redList[self.selectedData.mainIndex]);
end

function Lua_RuneCompoundPanel:onHelpClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(121531));
end

function Lua_RuneCompoundPanel:onUpdateItemChange()
	if self.selectedData.data ~= nil then
		self.runeCompoundPanel:setData(self.selectedData.data);
		self:updateShowRodDataList();
	end
end

-- 1成功，0失败
function Lua_RuneCompoundPanel:onUpdateEffect(state)
	if self.rsEffect ~= nil then
		self.rsEffect:dispose();
		self.rsEffect = nil;
	end

	if state == 1 then
		self.rsEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_hechengchenggong", "gui_hechengchenggong", 117, 15);
	else
		self.rsEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_hechengshibai", "gui_hechengshibai", 0, 0);
	end
	self.rsEffect:SetRenderQueue(self.rightBg, 100, 2, false);
end