-- 灵纹合成Panel
Lua_RuneCompoundSubPanel  = class("Lua_RuneCompoundSubPanel",Lua_DisplayObject);
function Lua_RuneCompoundSubPanel:ctor(p)	
	self:superCall("ctor", p, "RuneCompoundPanel_skin");
end

function Lua_RuneCompoundSubPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.leftImage = Lua_ToolImage.new(self.showObj1);
	self.leftImage:setDepth(7);

	self.centerImage = Lua_ToolImage.new(self.content);
	self.centerImage:setDepth(7);
	self.centerImage:setScale(1.3, 1.3);
	self.centerImage:setLocation(77, 11, 0);

	local tImg;
	self.materlsArr = Array();
	for i = 1, 2 do
		tImg = Lua_ToolImage.new(self["showObj" .. i + 1]);
		tImg:setDepth(7);
		self.materlsArr:add(tImg);
	end
	
	self.cohesionBtn:addClickFuntion(self, self.onCohesionClick);--凝聚	
end

function Lua_RuneCompoundSubPanel:setData(data)	
	self.data = data;

	--左侧
	self.ownEcrystal = DataCenter.runeData.ownEcrystal;
	self.name1.text = data.crystal_vo.colorName;
	self.leftImage.data = data.crystal_vo;
	self.leftImage:showNumLimit(self.ownEcrystal,data.cost_soul_stone,2)
	self.leftImage.num_txt.pivot = UIWidget.Pivot.Center;
	self.leftImage.num_txt:setLocation(0,-23,0);
	self.leftImage.num_txt.overflowMethod = UILabel.Overflow.ResizeFreely;

	--中间
	self.centerImage.data = data.item_vo;
	self.ylName.text = data.item_vo.colorName;

	local arrProp = data.item_vo.runeProp;
	for i = 1, arrProp:getSize() do
		if arrProp[i].type == 1 then
			self["ylProp"..i].text = LanUtil.formateStr(LanUtil.getValue(121536), tostring(arrProp[i].runePropName),tostring(arrProp[i].runePropNum));
		elseif arrProp[i].type == 2 then
			self["ylProp"..i].text = LanUtil.formateStr(LanUtil.getValue(121536), tostring(arrProp[i].runePropName),tostring(arrProp[i].runePropNum)).."%"; 
		end
	end

	self.successTxt.text = LanUtil.formateStr(LanUtil.getValue(124429),tostring(data.probability)); -- 成功率
	if data.needLevel ~= 0 then
		self.needLvlTxt.uiwidget.gameObject:SetActive(true);
		if DataCenter.roleData.Level >= data.needneedLevel then
			self.needLvlTxt.text = LanUtil.formateStr(LanUtil.getValue(124450),tostring(val.needLevel));
		else
			self.needLvlTxt.text = LanUtil.formateStr(LanUtil.getValue(124430),tostring(val.needLevel));
		end
	else
		self.needLvlTxt.uiwidget.gameObject:SetActive(false);
	end

	local _arr = data.cost_item_vo;
	if _arr ~= nil then
		for i=1,_arr:getSize() do
			self.materlsArr[i].data = _arr[i];
			self.materlsArr[i]:showNumLimit(_arr[i].bagNum,_arr[i].needNum,2)
			self.materlsArr[i]:showLockSlot(false);
			self["name"..i+1]:setEnable(true);
			self["name"..i+1].text = _arr[i].colorName;
		end
	else
		-- 单属性合成 (注：暂无配置)
		-- for i=1,self.materlsArr:getSize() do
		-- 	self.materlsArr[i].data = nil;
		-- 	self.materlsArr[i]:showLockSlot(true);
		-- end
		-- self.name2:setEnable(false);
		-- self.name3:setEnable(false);
	end
	self:updateIsShowRed();
end

function Lua_RuneCompoundSubPanel:onCohesionClick() --凝聚
	if self.data.needLevel <= DataCenter.roleData.level then
		local arr = self.data.cost_item;
		if arr ~= nil then
			local bagNum1 = DataCenter.packData:getBagType(Lua_PackData.LW_PACK):getItemNum(arr[1][1]);
			local bagNum2 = DataCenter.packData:getBagType(Lua_PackData.LW_PACK):getItemNum(arr[2][1]);
			local needNum1 = arr[1][2];
			local needNum2 = arr[2][2];
			if self.ownEcrystal >= self.data.cost_soul_stone and bagNum1 >= needNum1 and bagNum2 >= needNum2 then
				local doubleArray = self.data.getRuneDoubleArray;
				Lua_ProxyManager.getProxy("Lua_RuneProxy"):sCompoundRune(self.data.id,doubleArray);
			else
				OperateAlert.show(LanUtil.getValue(121533));
			end
		else
			-- 单属性合成 (注：暂无配置)
			-- if self.ownEcrystal >= self.data.cost_soul_stone then
			-- 	Lua_ProxyManager.getProxy("Lua_RuneProxy"):sCompoundRune(self.data.id);
			-- else
			-- 	OperateAlert.show(LanUtil.getValue(124432));
			-- end
		end
	else
		OperateAlert.show(LanUtil.getValue(121532));
	end

end

-- 更新凝聚红点
function Lua_RuneCompoundSubPanel:updateIsShowRed()
	if self.data.needLevel <= DataCenter.roleData.level then
		local arr = self.data.cost_item;
		if arr ~= nil then
			local bagNum1 = DataCenter.packData:getBagType(Lua_PackData.LW_PACK):getItemNum(arr[1][1]);
			local bagNum2 = DataCenter.packData:getBagType(Lua_PackData.LW_PACK):getItemNum(arr[2][1]);
			local needNum1 = arr[1][2];
			local needNum2 = arr[2][2];
			self:showRedDot(self.ownEcrystal >= self.data.cost_soul_stone and bagNum1 >= needNum1 and bagNum2 >= needNum2);
		else
			-- 单属性合成 (注：暂无配置)
			-- if self.ownEcrystal >= self.data.cost_soul_stone then
			-- 	self:showRedDot(true);
			-- else
			-- 	self:showRedDot(false);
			-- end
		end
	else
		self:showRedDot(false);
	end
end

function Lua_RuneCompoundSubPanel:showRedDot(val)
	if val then
		if self._redDot == nil then
			self._redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 178, -233, 0, 0);
			self._redDot.name = "redDot";
			self._redDot:setDepth(10);
		end
		self._redDot:setEnable(true);
	else
		if self._redDot ~= nil then
			self._redDot:setEnable(false);
		end
	end
end

function Lua_RuneCompoundSubPanel:dispose()
	if self._redDot ~= nil then
		self._redDot:dispose();
		self._redDot = nil;
	end
	self:superCall("dispose");
end