Lua_RuneExchangePanel = class("Lua_RuneExchangePanel", Lua_DisplayObject);
function Lua_RuneExchangePanel:ctor(p)
	self:superCall("ctor", p, "RuneExchangePanel_skin");
end

function Lua_RuneExchangePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 1113, 488));
	self.dragList:setLocation(-53, -38, 0);
	self.dragList:setListCell(Lua_RuneExchangeItem, 122, 555, 2);
	self.dragList:setLuaArrayData(DataCenter.runeUtil.exchangeRunesInfoArr, false);

	self.tipsLab:addClickFuntion(self, self.onGotoTxtClick);

	self:updateChips();

	Lua_ProxyManager.getProxy("Lua_RuneProxy"):sOpenRuneExchangeInfo();
	self:addLuaEvent("update_runeType_unlock", self, self.onUpdateRuneTypeUnlock);
end

function Lua_RuneExchangePanel:onGotoTxtClick()
	Lua_WindowUtil.openWin("Lua_TreasureWindow", WinParam.ACTION_OPEN, 2);
	Lua_WindowUtil.openWin("Lua_LifeSoulWindow", WinParam.ACTION_CLOSE);
end

function Lua_RuneExchangePanel:onUpdateRuneTypeUnlock()
	local arr = self.dragList.showList;
	for i = 1, arr:getSize() do 
		arr[i]:updateData();
	end
	self:updateChips();
end

function Lua_RuneExchangePanel:updateChips()
	self.suipianLab.text = LanUtil.getValue(121503) .. DataCenter.runeData.runeChip;
end

function Lua_RuneExchangePanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_RuneExchangeItem = class("Lua_RuneExchangeItem", Lua_ListCell);
function Lua_RuneExchangeItem:ctor(p)
    self:superCall("ctor", p, "RuneExchangeItem_skin");
end

function Lua_RuneExchangeItem:buildShowItem()
    self:superCall("buildShowItem");

    self.item = Lua_ToolImage.new(self.content);
    self.item:setDepth(5);
    self.item:setLocation(-222, 0, 0);
    
    self.exchangeButton:addClickFuntion(self, self.onExChangeClick);
end

function Lua_RuneExchangeItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.vo = data.vo;
	self.item.data = data.vo;
	self.arr = data.vo.runeProp;
	self.runeLvLab.text = data.vo.runeName;

	self:updateData();
end

function Lua_RuneExchangeItem:updateData()
	if self.data == nil then
		return;
	end

	self.exchangeButton:setGray(true);
	if self.vo.rune_type == 1 then
		self.rune_pro.text = self.vo.runeExeProp;
		self.rune_lab.text ="";
	else
		for i = 1, self.arr:getSize() do
			if self.arr[i].type == 1 then
				self.rune_pro.text = LanUtil.formateStr(LanUtil.getValue(121522), tostring(self.arr[i].runePropName),tostring(self.arr[i].runePropNum));
			elseif self.arr[i].type == 2 then
				self.rune_pro.text = LanUtil.formateStr(LanUtil.getValue(121522), tostring(self.arr[i].runePropName),tostring(self.arr[i].runePropNum)).."%"; 
			end
		end

		if self.vo.isShowNnlock == true then
			self.rune_lab.text ="";
		else
			self.rune_lab.text =LanUtil.formateStr(LanUtil.getValue(121506), tostring(self.vo.unlock_cond_show));
		end
	end

	if DataCenter.runeData.runeChip >= self.data.cost then
		self.exchangeButton:setGray(not self.vo.isShowNnlock);
		self.chipNum.text = "[00E125]" .. self.data.cost .. "[-]";
	else
		self.exchangeButton:setGray(true);
		self.chipNum.text = "[FF1616]" .. self.data.cost .. "[-]";
	end
end

function Lua_RuneExchangeItem:onExChangeClick()
	if self.unlock_typebool == true then
		OperateAlert.show(LanUtil.getValue(121504));
		return;
	end

	if self.vo.isShowNnlock == true then
		if DataCenter.runeData.runeChip >= self.data.cost then -- 兑换灵纹
			Lua_ProxyManager.getProxy("Lua_RuneProxy"):sExchangeRune(self.data.runeId);
		else
			OperateAlert.show(LanUtil.getValue(121505));
		end
	else
		OperateAlert.show(LanUtil.getValue(121504));
	end
end

function Lua_RuneExchangeItem:dispose()
	if self.item ~= nil then
		self.item:dispose();
		self.item = nil;
	end

	self:superCall("dispose");
end