-- 灵纹背包
Lua_RunePackWindow = class("Lua_RunePackWindow", Lua_Window)
function Lua_RunePackWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_RunePackWindow";
	self.skinName = "RunePackWindow_skin";
	self.showBg = false;
	self.showClose = false;
end

function Lua_RunePackWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.titleNameText.text = LanUtil.getValue(121509);

	self.recordsList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 1080, 440));
	self.recordsList:setLocation(4, 13, 0);
	self.recordsList:setListCell(Lua_RunePackItem, 133, 535, 2);

	self.tipsLab.text = LanUtil.getValue(121528);
	self.tipsLab:addClickFuntion(self, self.onClickTxt);
	self.getRuneBtn:addClickFuntion(self, self.onHuoquClick);
    
    self:onUpdateData();
	self:addLuaEvent("PACK_RUNE_UPDATE", self, self.onUpdateData)
end

function Lua_RunePackWindow:showWin(param)
	self:superCall("showWin", param);

	if param ~= nil then
		self.showTypeArr = param.showTypeArr;
		self.grooveId = param.grooveId;
	else
		self.grooveId = nil;
		self.showTypeArr = nil;
	end
	self:onUpdateData();
end 

-- 更新背包数据
function Lua_RunePackWindow:onUpdateData()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.LW_PACK);
	local arr;
	if self.showTypeArr ~= nil then -- 显示对应类型灵纹
		arr = bagData:getItemsBySubType(self.showTypeArr);
	else -- 显示所有灵纹
		arr = bagData:getBagAllData();
	end

	-- 排序
	local result = Array();
	local len = arr:getSize();
	for i = 1, len do
		for j = i + 1,len do
			if not DataCenter.runeData:sortFun(arr[i], arr[j]) then
				local temp = arr[i]
				arr[i] = arr[j]
				arr[j] = temp
			end
		end
		result:add({data = arr[i], grooveId = self.grooveId});
	end
	self.recordsList:setLuaArrayData(result, false);
end

function Lua_RunePackWindow:onClickTxt(go)
	Lua_WindowUtil.openWin("Lua_TreasureWindow", WinParam.ACTION_OPEN, 2);
	Lua_WindowUtil.openWin("Lua_RunePackWindow", WinParam.ACTION_CLOSE);
end

function Lua_RunePackWindow:onHuoquClick()
	Lua_WindowUtil.openWin("Lua_CopyLingWenWindow", WinParam.ACTION_OPEN, DataCenter.copyData:getCopyById(Lua_CopyData.LINGWEN_COPY));
	Lua_WindowUtil.openWin("Lua_RuneWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_TreasureWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_RunePackWindow", WinParam.ACTION_CLOSE);
end

function Lua_RunePackWindow:dispose()
	if self.recordsList ~= nil then
		self.recordsList:dispose()
		self.recordsList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_RunePackItem = class("Lua_RunePackItem", Lua_ListCell);
function Lua_RunePackItem:ctor(p)
	self:superCall("ctor", p, "RunePackItem_skin");
end

function Lua_RunePackItem:buildShowItem()
	self:superCall("buildShowItem");

	self.pro = {self.rune_pro, self.rune_pro2};

	-- bg_hide 名字不要改，给指引功能那边用，不要删，改了的话，要告诉策划那边
	self.bg_hide.clickScale = false;
	self.bg_hide.alpha = 0.1;
	self.bg_hide:setDepth(-2);
	self.bg_hide:addClickFuntion(self, self.onPlayerSoundClick);

	self.rune:addClickFuntion(self, self.onIconClick);
end

function Lua_RunePackItem:setData(data)
	self.vo = data.data;
	self.grooveId = data.grooveId;

	self.pro[2].text = ""
	self.pro[2]:setEnable(false);
	if self.vo ~= nil then
		self.rune:setAltas(self.vo.atlas, self.vo.referenceId);
		self.rune:resetSize();
		
		self.runeLvLab.text = self.vo.runeName;

		self.propArr = self.vo.runeProp;
		if self.vo.rune_type == 1 then
			self.pro[1].text = self.vo.runeExeProp;
		else
			self.pro[2]:setEnable(self.propArr:getSize() > 1);
			for i = 1, self.propArr:getSize() do
				if self.propArr[i].type == 1 then
					self.pro[i].text = LanUtil.formateStr(LanUtil.getValue(121522), tostring(self.propArr[i].runePropName), tostring(self.propArr[i].runePropNum));
				elseif self.propArr[i].type == 2 then
					self.pro[i].text = LanUtil.formateStr(LanUtil.getValue(121522), tostring(self.propArr[i].runePropName), tostring(self.propArr[i].runePropNum)).."%"; 
				end
			end
		end
	end
	self.hasAtrrObj:SetActive(DataCenter.runeData:isShowPossessSign(self.vo.attribute));
end

-- 替换灵纹
function Lua_RunePackItem:onPlayerSoundClick(go)
	if self.grooveId == nil then
		return;
	end
	
	if self.vo.rune_type == 1 then
		OperateAlert.show(LanUtil.getValue(121510));
		return;
	end

	local vo = DataCenter.runeData:getArrByGrooveId(self.grooveId);
	if vo ~= nil and(vo.runeId ~= 0 and vo.runeId ~= nil) then -- 替换
		Lua_ProxyManager.getProxy("Lua_RuneProxy"):sReplaceRune(self.grooveId , self.vo.id, self.vo.index);
	else -- 镶嵌
		Lua_ProxyManager.getProxy("Lua_RuneProxy"):sInlayRune(self.grooveId, self.vo.id, self.vo.index);
	end
	Lua_WindowUtil.openWin("Lua_RunePackWindow");
end

function Lua_RunePackItem:onIconClick(go)
	if self.vo ~= nil then
		Lua_PackUtil.showItemInfo(self.vo, false);
	end
end

function Lua_RunePackItem:dispose()
	self:superCall("dispose");
end