checkRequire("Lua_RuneItem");
Lua_RunePanel = class("Lua_RunePanel", Lua_DisplayObject);
function Lua_RunePanel:ctor(p)
	self:superCall("ctor", p, "RunePanel_skin");
end

function Lua_RunePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.effectList = {self.effect1, self.effect2, self.effect3, self.effect4, self.effect5,
		self.effect6, self.effect7, self.effect8, self.effect9, self.effect10} -- 光标特效
	self.pro = {self.pro1, self.pro2, self.pro3, self.pro4} -- 四条属性gameObject
	self.prolab = {self.pro1lab, self.pro2lab, self.pro3lab, self.pro4lab} -- 属性名
	self.protxt = {self.pro1txt, self.pro2txt, self.pro3txt, self.pro4txt} -- 属性值
	self.add = {self.add1, self.add2, self.add3, self.add4} -- 增加属性值gameObject
	self.addlab = {self.add1lab, self.add2lab, self.add3lab, self.add4lab} -- 增加属性值

	for i = 1, #self.effectList do
		self.effectList[i]:setEnable(false); -- 设置默认
	end

	for i = 1, #self.pro do
		self.pro[i]:SetActive(false); -- 设置默认
	end

	self.rightItem = Lua_RuneItem.new(self.content);
	self.rightItem:setDepth(5);
	self.rightItem:setLocation(345, 86, 0);
	self.rightItem:setShowSelect(false);
	self.rightItem.isBool = true;

	local item;
	local poses = {{-223, 126}, {-46, 68}, {-98, -43}, {-46, -154}, {-223, -207}, {-399, -154}, {-349, -43}, {-399, 68}, {-223, 18}, {-223, -94}};
	self.itemArr = Array();
	for i, v in ipairs(poses) do
		item = Lua_RuneItem.new(self.content);
		item:setDepth(5);
		item:setCanClick(true);
		item:setShowSelect(false);
		item:setRuneNnmetype(i); -- 灵纹名字编号
		item:updataUI(i);
		item:setLocation(v[1], v[2], 0);
		self.itemArr:add(item);
	end

	self.fightNum = Lua_NumberImage.new(self.content);
	self.fightNum.numWidth = 13;
	self.fightNum:setDepth(6);
	self.fightNum:setLocation(-485, 182, 0);

	self.changeButton:addClickFuntion(self, self.onChangeButtonClick);
	self.upgradeButton:addClickFuntion(self, self.onUpgradeButtonClick);
	self.runeAllShow:addClickFuntion(self, self.onAllShowClick); -- 总览
	-- self.runeResolve:addClickFuntion(self, self.onResolveClick); -- 分解
	-- self.runeExchange:addClickFuntion(self, self.onExchangeClick); -- 兑换
	-- self.runeCompound:addClickFuntion(self, self.onCompoundClick); -- 合成
	self.leftwenhao:addClickFuntion(self, self.onHelpClick); -- 问号

	--self.compoundRed:setEnable(false);
	--Lua_ProxyManager.getProxy("Lua_RuneProxy"):sOpenRunePanelInfo();

	self:addLuaEvent("rOpenRunePanelInfo", self, self.openRunePanelInfo) -- 打开灵纹面板
	self:addLuaEvent("RSELECTUNLOCKEDINFO", self, self.selectUnlocked) -- 选择已解锁镶嵌槽

	self:addLuaEvent("SHOWSELECTRUNE", self, self.onUpShowSelectClick) -- 点击事件
	self:openRunePanelInfo();
end

-- 打开灵纹面板
function Lua_RunePanel:openRunePanelInfo()
	--print("打开灵纹面板返回")
	self.presetsOpenLab.text = LanUtil.getValue(121521);
	self.fightNum.num = DataCenter.runeData.getAllRuneForce;
	local data = DataCenter.runeData.runeHolesInfo;
	for k,v in pairs(data) do
		if v.id ~= nil then
			self.itemArr[v.id+1]:setRunetype(v);
			if v.unLock  then
				self.effectList[v.id + 1]:setEnable(true);
			end
		end
	end

	if self.isDefault == true then
		self.itemArr[1]:onIconClick(1); -- 打开界面默认选择一号灵纹槽
		self.isDefault = false;
	end

	-- 合成功能屏蔽判断
	-- if DataCenter.runeData.isOpenCompound == true then
	-- 	self.runeCompound:setGray(false);
	-- 	self:updateIsShowCompoundRed();
	-- else
	-- 	self.advance = getConfig({"func_open", 10157}).advance_function;
	-- 	if self.advance == 1 then
	-- 		self.runeCompound:setGray(true);
	-- 	end
	-- end
	--self:updateIsShowResolveRed();
	self:onUpShowSelectClick();
end

-- 点击选择灵纹
function Lua_RunePanel:onUpShowSelectClick()
	local grooveId = DataCenter.runeData.grooveId;
	self.vo = DataCenter.runeData:getArrByGrooveId(grooveId);
	for i = 1, self.itemArr:getSize() do
		if self.vo.id + 1 == i then
			self.itemArr[self.vo.id + 1]:setShowSelect(true);
		else
			self.itemArr[i]:setShowSelect(false);
		end
	end

	if self.vo.unLock and self.vo.runeId ~= nil and self.vo.runeId ~= 0 then
		self.runeLvLab:setEnable(true);
		self.runeNameLab:setEnable(true);
		Lua_ProxyManager.getProxy("Lua_RuneProxy"):sSelectUnlockedNum(self.vo.id);
	else
		for i = 1, #self.pro do
			self.pro[i]:SetActive(false); -- 设置属性条默认
		end
		self.runeLvLab:setEnable(false);
		self.runeNameLab:setEnable(false);
		self.consume:SetActive(false);
		self.changeButton:setEnable(false);
		self.upgradeButton:setEnable(false);
	end

	if DataCenter.runeUtil:groove_unlock_cond(self.vo.id + 1) > 0 then -- 灵纹塔解锁层数显示
		self.presetsOpenLab.clickScale = true;
		self.presetsOpenLab:addClickFuntion(self, self.onRuneTowerUnlockClick);
		self.presetsOpenLab.text = LanUtil.formateStr(LanUtil.getValue(121513), tostring(DataCenter.runeUtil:groove_unlock_cond(self.vo.id + 1)));
	else
		self.presetsOpenLab.clickScale = false;
		self.presetsOpenLab:removeClickFuntion(self, self.onRuneTowerUnlockClick);
		self.presetsOpenLab.text = LanUtil.getValue(121521);
	end

	--升级红点判断
	if self.vo.unLock and self.vo.runeId ~= nil and self.vo.runeId ~= 0 then
		if self.vo.ownEssence >= self.vo.upCostEssence and self.vo.bFullLv == false then
			self:showRedUpgradeDot(true);
		else
			self:showRedUpgradeDot(false);
		end
	else
		self:showRedUpgradeDot(false);  
	end

	self.rightItem:setRunetype(self.vo); -- 右侧Item 显示
	self:updateIsShowChangeRed();
end

function Lua_RunePanel:selectUnlocked() -- 选择已解锁镶嵌槽 显示
	local runeVo = self.vo.runeVo;
	if runeVo == nil then
		return;
	end

	local porArray = runeVo.runeProp; -- 属性
	if porArray == nil then
		return;
	end
	self.needEssence = tonumber(self.vo.upCostEssence); -- 升级所需符文精华 
	self.ownEssence = tonumber(self.vo.ownEssence); -- 自己拥有的精华

	self.runeLvLab.text = runeVo.runeShowLevel;
	self.runeNameLab.text = runeVo.runeShowName;

	for i = 1, #self.pro do
		self.pro[i]:SetActive(false); -- 设置属性条默认
	end

	for i = 1, porArray:getSize() do
		self.pro[i]:SetActive(true);
		self.prolab[i].text = porArray[i].runePropName .. "：";
		if self.vo.bFullLv then
			-- self.pro[i].transform.localPosition = Vector3(203, -61 - 33 * i, 0);
			LuaUtil.setObjPos(self.pro[i], 203, -61 - 33 * i, 0);
		end
		self.add[i]:SetActive(not self.vo.bFullLv);

		if porArray[i].type == 1 then
			self.protxt[i].text = "+" .. porArray[i].runePropNum;
			self.addlab[i].text = "+" .. porArray[i].nextRunePropNum;
			self:updaLabelPos(self.prolab[i], self.protxt[i], self.add[i]);
		elseif porArray[i].type == 2 then
			self.protxt[i].text = "+" .. porArray[i].runePropNum .. "%"
			self.addlab[i].text = "+" .. porArray[i].nextRunePropNum .. "%"
			self:updaLabelPos(self.prolab[i], self.protxt[i], self.add[i]);
		end
	end
	-- self.consume.transform.localPosition = Vector3(203, -94 - 33 * porArray:getSize(), 0); -- 消耗位置
	LuaUtil.setObjPos(self.consume, 203, -94 - 33 * porArray:getSize(), 0);

	if self.ownEssence >= self.needEssence then -- 灵纹精华显示
		self.consumetxt.text = self.ownEssence.."/"..self.needEssence;
	else
		self.consumetxt.text =  "[FF1616]"..self.ownEssence.."[-]/"..self.needEssence;
	end

	if self.vo.bFullLv then -- 灵纹是否满级满级
		self:showRedChangeDot(false);
		self:showRedUpgradeDot(false); 
		self.consumetxt.text = LanUtil.getValue(121525);
		self.upgradeButton:setBtnEnable(false)
		self.consumelab:setEnable(false);
		self.consumebg:setEnable(false);
		-- self.consume.transform.localPosition = Vector3(-80, -75 - porArray:getSize() * 30, 0);--消耗位置
		LuaUtil.setObjPos(self.consume, 93, -94 - 33 * porArray:getSize(), 0);
	else
		self.consumebg:setEnable(true);
		self.upgradeButton:setBtnEnable(true)
		self.consumelab:setEnable(true);
		self.consume:SetActive(true);
		self.changeButton:setEnable(true);
		self.upgradeButton:setEnable(true);
	end
	self:updateIsShowChangeRed();
end

function Lua_RunePanel:updaLabelPos(prolab, protxt, addObj)
	protxt:setLocation(prolab.width, 0, 0);
	-- addObj.transform.localPosition = Vector3(protxt.mainContent.transform.localPosition.x + protxt.width + 30, 0, 0);
	LuaUtil.setObjPos(addObj, protxt.mainContent.transform.localPosition.x + protxt.width + 10, 0, 0);
end

-- 红点更新
function Lua_RunePanel:updateIsShowChangeRed()
	if self.vo.unLock and self.vo.runeId ~= nil and self.vo.runeId ~= 0 then
		local isShowChangeRed = DataCenter.runeData:isShowChangeRed(self.vo.id);
		if isShowChangeRed == true then
			self:showRedChangeDot(true); -- 替换红点显示
		else
			self:showRedChangeDot(false);
		end
	else
		self:showRedChangeDot(false); 
	end
end

-- function Lua_RunePanel:updateIsShowCompoundRed() -- 合成红点更新
-- 	local isShowCompoundRed = DataCenter.runeData:isShowCompoundRed();
-- 	if isShowCompoundRed == true then
-- 		self.compoundRed:setEnable(true);
-- 	else
-- 		self.compoundRed:setEnable(false);
-- 	end
-- end

function Lua_RunePanel:updateIsShowResolveRed() -- 分解红点更新
	local isShowResolveRed = DataCenter.runeData:isShowResolveRed();
	if isShowResolveRed == true then
		self:showRedResolveDot(true);
	else
		self:showRedResolveDot(false);
	end
end

function Lua_RunePanel:onChangeButtonClick() -- 灵纹替换
	Lua_WindowUtil.openWin("Lua_RunePackWindow", WinParam.ACTION_OPEN,{grooveId = self.vo.id});
end

function Lua_RunePanel:onUpgradeButtonClick() -- 灵纹升级
	if self.vo.bFullLv then
		OperateAlert.show(LanUtil.getValue(121514));
		return;
	end

	if self.vo ~= nil and self.ownEssence >= self.needEssence then
		Lua_ProxyManager.getProxy("Lua_RuneProxy"):sUpgradeRune(self.vo.id);
	else
		OperateAlert.show(LanUtil.getValue(121515));
	end
end

-- function Lua_RunePanel:showRedResolveDot(val) -- 分解红点显示
-- 	if val == true then
-- 		if self._redDotIcon == nil then
-- 			self._redDotIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", -445, -273, 0, 0);
-- 			self._redDotIcon:setDepth(7);
-- 			self._redDotIcon.name = "redDotIcon1";
-- 		end
-- 		self._redDotIcon:setEnable(true);
-- 	else
-- 		if self._redDotIcon ~= nil then
-- 			self._redDotIcon:setEnable(false);
-- 		end
-- 	end
-- end

function Lua_RunePanel:showRedChangeDot(val) -- 替换红点显示
	if val == true then
		if self._redChangeDotIcon == nil then
			self._redChangeDotIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 329, -287, 0, 0);
			self._redChangeDotIcon:setDepth(7);
			self._redChangeDotIcon.name = "redDotIcon2";
		end
		self._redChangeDotIcon:setEnable(true);
	else
		if self._redChangeDotIcon ~= nil then
			self._redChangeDotIcon:setEnable(false);
		end
	end
end

function Lua_RunePanel:showRedUpgradeDot(val) -- 升级红点显示
	if val == true then
		if self._redUpgradeDotIcon == nil then
			self._redUpgradeDotIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 483, -287, 0, 0);
			self._redUpgradeDotIcon:setDepth(7);
			self._redUpgradeDotIcon.name = "redDotIcon3";
		end
		self._redUpgradeDotIcon:setEnable(true);
	else
		if self._redUpgradeDotIcon ~= nil then
			self._redUpgradeDotIcon:setEnable(false);
		end
	end
end

function Lua_RunePanel:onRuneTowerUnlockClick() -- 打开灵纹塔
	Lua_WindowUtil.openWin("Lua_LifeSoulWindow");
	Lua_WindowUtil.openWin("Lua_CopyLingWenWindow", nil, DataCenter.copyData:getCopyById(Lua_CopyData.LINGWEN_COPY));
end

function Lua_RunePanel:onAllShowClick()
	Lua_WindowUtil.openWin("Lua_RuneAllShowWindow");
end

-- function Lua_RunePanel:onResolveClick()
-- 	Lua_WindowUtil.openWin("Lua_RuneResolveWindow");
-- end

-- function Lua_RunePanel:onExchangeClick()
-- 	Lua_WindowUtil.openWin("Lua_RuneExchangeWindow");
-- end

function Lua_RunePanel:onCompoundClick()
	if self.advance == 1 then
		local s = getConfig({"func_open", 10157, "advance_message"});
		if s ~= nil then
			OperateAlert.show(s);
		end
	else
		Lua_WindowUtil.openWin("Lua_RuneCompoundWindow");
	end
end

function Lua_RunePanel:onHelpClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, LanUtil.getValue(121501));
end

function Lua_RunePanel:dispose()
	if self._redChangeDotIcon ~= nil then
		self._redChangeDotIcon:dispose();
		self._redChangeDotIcon = nil;
	end
	if self._redUpgradeDotIcon ~= nil then
		self._redUpgradeDotIcon:dispose();
		self._redUpgradeDotIcon = nil;
	end
	self:superCall("dispose");
end