-- 灵纹item
Lua_RuneItem = class("Lua_RuneItem", Lua_DisplayObject);
function Lua_RuneItem:ctor(p)
	self:superCall("ctor", p, "RuneItem_skin");
end

function Lua_RuneItem:buildShowItem()
	self:superCall("buildShowItem");

	self.isBool = false;
end

function Lua_RuneItem:setRuneNnmetype(val)
	self.runeType = val;
	self.content.name = "Lua_RuneItem"..tostring(val);
end

function Lua_RuneItem:setRunetype(data)
	self.data = data;

	if data == nil then
		self.lock:setEnable(true);
		self.add:setEnable(false);
		self:setShowRun(false);
		self:showRedDot(false);
		self:setShowRunLvl(nil);
	else
		self.lock:setEnable(not data.unLock);
		self:setShowRunLvl(nil);
		if self.isBool == false then
			if data.unLock then
				if data.runeId == 0 or data.runeId == nil then
					if data.id < 8 then
						self.add:setEnable(true);
						-- 背包是否有灵纹
						self:showRedDot(DataCenter.runeData:updateIsRuneInlayRed());
					else
						self.add:setEnable(false);
						if DataCenter.runeData:updateIsKernelRed() == true then -- 背包 是否有 核心灵纹            
							self:showRedDot(true); 
							local ablow = DataCenter.runeData.ablow;
							local defense = DataCenter.runeData.defens;
							if data.id == 8  then
								self:showRedDot(ablow);
							elseif data.id == 9  then
								self:showRedDot(defense);
							end 
						else
							self:showRedDot(false);
						end  
					end
					self:setShowRun(false);
				else
					local isShowChangeRed = DataCenter.runeData:isShowChangeRed(self.data.id) -- 替换红点判断；
					local ownEssence = data.ownEssence; -- 拥有精华
					local upCostEssence = data.upCostEssence -- 升级需要精华
					self:showRedDot(isShowChangeRed or (ownEssence >= upCostEssence and data.bFullLv == false));
					self.add:setEnable(false);
					self:setShowRun(true, data.runeId);
					self:setShowRunLvl(data.runeVo.runeShowLevel);
				end
			else
				self.add:setEnable(false);
				self:setShowRun(false);
				self:showRedDot(false);
			end
		else
			self.add:setEnable(data.unLock and (data.runeId == 0 or data.runeId == nil));

			local setShowRuneState = data.unLock and (data.runeId ~= nil and data.runeId ~= 0);
			self:setShowRun(setShowRuneState, setShowRuneState and data.runeId or nil);
		end
	end
end

-- 灵纹背景添加点击方法
function Lua_RuneItem:setCanClick(val)
	if val == true then
		self.runeBg.mouseEnable = true;
		self.runeBg:addClickFuntion(self, self.onIconClick);
	else
		self.runeBg.mouseEnable = false;
		self.runeBg:removeClickFuntion(self, self.onIconClick);
	end
end

-- 灵纹等级显示
function Lua_RuneItem:setShowRunLvl(runeLv)
	if runeLv ~= nil then
		-- self.di:setEnable(true);
		self.runeLvLab:setEnable(true);
		self.runeLvLab.text = runeLv;
	else
		-- self.di:setEnable(false)
		self.runeLvLab:setEnable(false)
	end
end

function Lua_RuneItem:updataUI(val)
	if val > 8 then
		self.runeBg:setAltas("minghun_atlas", "ui_minghun_lingwenkuan_5");
		self.runeBg:setLocation(0, 3, 0);
		self.add:setEnable(false);

		self.btnTxt = UICreate.createLabel(self.content, "", 0, 0, 100, 30, 18);
		self.btnTxt.pivot = UIWidget.Pivot.Center;
		self.btnTxt:setDepth(8);
		self.btnTxt.text = val == 9 and LanUtil.getValue(121526) or LanUtil.getValue(121527);

		self.exprain = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_lingwen_kong","gui_lingwen_kong", 0, 6.5);
		self.exprain:SetRenderQueue(self.runeBg, 3, 2, false);
	else
		self.runeBg:setAltas("minghun_atlas", "ui_minghun_lingwenkuan_2");
		self.runeBg:setLocation(0, 0, 0);
	end
end

-- 灵纹显示
function Lua_RuneItem:setShowRun(val, id) 
	if val then
		self.runeIcon:setAltas("item3", tostring(id));
	end
	self.runeIcon:setEnable(val);
end

function Lua_RuneItem:setShowSelect(val)
	self.select:setEnable(val);
end

function Lua_RuneItem:setDepth(val)
	self:superCall("setDepth", val);

	self.bg:setDepth(val);
	self.runeBg:setDepth(val + 1);
	self.select:setDepth(val + 10);
	self.add:setDepth(val + 2);
	self.lock:setDepth(val + 3);
	self.runeIcon:setDepth(val + 4);
	self.runeLvLab:setDepth(val + 5);
end

function Lua_RuneItem:showRedDot(val)
	if val == true then
		if self._redDotIcon == nil then
			self._redDotIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 40, 30, 0, 0);
			self._redDotIcon:setDepth(10);
			self._redDotIcon.name = "redDot";
		end
		self._redDotIcon:setEnable(true);
	else
		if self._redDotIcon ~= nil then
			self._redDotIcon:setEnable(false);
		end
	end
end

function Lua_RuneItem:onIconClick(go)
	if self.data == nil then
		return;
	end

	DataCenter.runeData.grooveId = self.data.id;
	if go ~= 1 then -- 打开界面默认选择判定，不等于1 执行下面方法
		if self.data ~= nil and self.data.id ~= nil then
			if self.data.unLock and (self.data.runeId == nil or self.data.runeId == 0) then
				Lua_WindowUtil.openWin("Lua_RunePackWindow", WinParam.ACTION_OPEN,{grooveId = self.data.id});
			end
		end
	end
	Lua_MsgUtil.callFunc("SHOWSELECTRUNE");
end

function Lua_RuneItem:dispose()
	self:superCall("dispose");
end