-- 符文展示item
Lua_RuneShowItem = class("Lua_RuneShowItem", Lua_DisplayObject);
function Lua_RuneShowItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_RuneShowItem:buildShowItem()
	self:superCall("buildShowItem");

	self.item = Lua_ToolImage.new(self.content);
	self.item:setCanClick(false);

	self.runeLvLab = UICreate.createLabel(self.content, "", 0, -53, 250, 30, 20);
	self.runeLvLab.pivot = UIWidget.Pivot.Center;
	self.runeLvLab.overflowMethod = UILabel.Overflow.ResizeFreely;
end

function Lua_RuneShowItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.item.data = data;
	self.runeLvLab.text = data.runeName;
end

function Lua_RuneShowItem:checkMouseClick(vec)
	local pos = self.content.transform.localPosition;
	if vec.x >= pos.x - 40 and vec.x <= pos.x + 40 and vec.y >= pos.y - 40 and vec.y <= pos.y + 40 then
		return true;
	end
	return false;
end

function Lua_RuneShowItem:showItemTip()
	if self.data ~= nil then
		Lua_PackUtil.showItemInfo(self.data);
	end
end

function Lua_RuneShowItem:dispose()
	if self.item ~= nil then
		self.item:dispose();
		self.item = nil;
	end
	if self.runeLvLab ~= nil then
		self.runeLvLab:dispose();
		self.runeLvLab = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end