-- 魂印合成Panel
Lua_StampCompoundPanel  = class("Lua_StampCompoundPanel",Lua_DisplayObject);
function Lua_StampCompoundPanel:ctor(p)	
	self:superCall("ctor", p, "StampCompoundPanel_skin");
end

function Lua_StampCompoundPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.leftImage = Lua_ToolImage.new(self.showObj1);
	self.leftImage:setDepth(5);

	self.centerImage = Lua_ToolImage.new(self.content);
	self.centerImage:setDepth(5);
	self.centerImage:setLocation(135, 47, 0);

	local tImg;
	self.materlsArr = Array();
	for i = 1, 2 do
		tImg = Lua_ToolImage.new(self["showObj" .. i + 1]);
		tImg:setDepth(5);
		self.materlsArr:add(tImg);
	end
	self.cohesionBtn:addClickFuntion(self, self.onCohesionClick);
end

function Lua_StampCompoundPanel:setData(data)
	self.data = data;

	-- 左侧
	self.name1.text = data.materials_vo.colorName;
	self.leftImage.data = data.materials_vo;
	self.leftImage:showNumLimit(data.materials_have_num,data.materials_num,2)
	self.leftImage.num_txt.pivot = UIWidget.Pivot.Center;
	self.leftImage.num_txt:setLocation(0,-23,0);
	self.leftImage.num_txt.overflowMethod = UILabel.Overflow.ResizeFreely;

	-- 中间
	self.centerImage.data = data.item_vo;
	self.centerImage:showStampEff(true);
	self.ylName.text = data.item_vo.colorName;
	self.ylProp.text = data.item_vo.stampBaseProp
	self.successTxt.text = LanUtil.formateStr(LanUtil.getValue(124429),tostring(data.probability)); -- 成功率

	local _arr = data.cost_item_vo;
	if _arr ~= nil then
		for i = 1, self.materlsArr:getSize() do
			if _arr[i] ~= nil then
				self.materlsArr[i].data = _arr[i];
				self.materlsArr[i]:showNumLimit(_arr[i].bagNum,_arr[i].needNum,2)
				self.materlsArr[i]:showLockSlot(false);
				self.materlsArr[i]:showStampEff(true);
				self["name"..i + 1]:setEnable(true);
				self["name"..i + 1].text = _arr[i].colorName;
			else
				self.materlsArr[i].data = nil;
				self.materlsArr[i]:showLockSlot(true);
				self["name"..i + 1]:setEnable(false);
			end
		end
	else
		for i = 1, self.materlsArr:getSize() do
			self.materlsArr[i].data = nil;
			self.materlsArr[i]:showLockSlot(true);
		end
		self.name2:setEnable(false);
		self.name3:setEnable(false);
	end
	self:showRedDot(self.data.isShowCompoundRed);
end

-- 合成
function Lua_StampCompoundPanel:onCohesionClick()
	if self.data.isShowCompoundRed == true then
		Lua_ProxyManager.getProxy("Lua_StampProxy"):sCompoundStamp(self.data.id,self.data.getCompoundItemArr);
	else
		OperateAlert.show(LanUtil.getValue(121533));
	end
end

function Lua_StampCompoundPanel:showRedDot(val)
	if val then
		if self._redDotIcon == nil then
			self._redDotIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 178, -207, 0, 0);
			self._redDotIcon:setDepth(7);
		end
		self._redDotIcon:setEnable(true);
	else
		if self._redDotIcon ~= nil then
			self._redDotIcon:setEnable(false);
		end
	end
end

function Lua_StampCompoundPanel:dispose()
	if self.leftImage ~= nil then
		self.leftImage:dispose();
		self.leftImage = nil;
	end
	if self.centerImage ~= nil then
		self.centerImage:dispose();
		self.centerImage = nil;
	end
	if self.materlsArr ~= nil then
		self.materlsArr:dispose();
		self.materlsArr:clear();
		self.materlsArr = nil;
	end
	self:superCall("dispose");
end