-- 魂印合成
checkRequire("Lua_StampCompoundPanel");
Lua_StampCompoundWindow = class("Lua_StampCompoundWindow", Lua_SecondSizeWindow)
function Lua_StampCompoundWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_StampCompoundWindow";
	self.skinName = "StampCompoundWindow_skin";
	self.titleText = LanUtil.getValue(128540);
end

function Lua_StampCompoundWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	self.stampCompoundPanle = Lua_StampCompoundPanel.new(self.content);

	local arr = DataCenter.stampUtil.getCompoundCalssInfo;
	self.btnList = Lua_DragSubButtonList.new(self.content, 1, Vector4(0, 0, 212, 520),
		Vector3(212, 66, 0), Vector3(195, 48, 0), Vector2(0, 0), Vector3(0, 16));
	self.btnList:setDepth(5);
	self.btnList:setMainBtnStyle("common_atlas_1", "ui_common_btn_p2", "ui_common_btn_p1", "D5DADE", "FFFFFF", 30);
	self.btnList:setSubBtnStyle("common_atlas_1", "ui_common_btn_p4", "ui_common_btn_p3", "FFFFFF", "FFFCB7", 26); -- "92A0DA"
	self.btnList:setLocation(-432, -31, 0);
	self.btnList:setData(arr, self, self.onButtonListClick, 0, 227); -- (520 - 66) / 2
	self.btnList:setMainSlected(1, 1);
	self.btnList.clickDrawBack = true;

	self.helpLab.text = LanUtil.getValue(128542);
	self.help:addClickFuntion(self, self.onHelp);

	self:updateShowRodDataList();
	
	self:addLuaEvent("UPDATE_STAMP_INFO", self, self.onUpdateItemChange);
	self:addLuaEvent("IS_SUCCEED_STAMP_STATE", self, self.onUpdateEffect);
end

function Lua_StampCompoundWindow:showWin(param)
	self:superCall("showWin", param);
	
	if type(param) == "table" then
		local index = DataCenter.gatherSoulUtil:getCompoundCalssId(param.data.id);
		local group_index = DataCenter.gatherSoulUtil:getCompoundGroupIndex(param.data.id,index);
		self.btnList:setMainSlected(index, group_index,false);
	elseif type(param) == "number" then
		self.btnList:setMainSlected(param, param, false);
	end
end

function Lua_StampCompoundWindow:onUpdateItemChange()
	if self.selectedData.data ~= nil then
		self.stampCompoundPanle:setData(self.selectedData.data);
		self:updateShowRodDataList();
	end
end

function Lua_StampCompoundWindow:onButtonListClick(data)
	self.selectedData = data;
	self.stampCompoundPanle:setData(data.data);
	self:updateWindowDepth();
	self:updateShowRodDataList();
end

function Lua_StampCompoundWindow:updateShowRodDataList()
	local info = DataCenter.stampUtil.getCalssConfigInfo;
	local list;
	local redList = {};
	for k,v in pairs(info) do
		list = DataCenter.stampUtil:updateShowRedList(k);
		for i,j in pairs(list) do
			redList[k] = j;
		end
	end
	self.btnList:setRedDot(1, redList);
	self:updateShowRed()
end

function Lua_StampCompoundWindow:updateShowRed()
	if self.selectedData == nil then
		return;
	end

	local info = DataCenter.stampUtil.getCalssConfigInfo;
	local redList = {};
	for k,v in pairs(info) do
		local list = DataCenter.stampUtil:getShowCompoundRedList(k);
		if v.stamp_group_list ~= nil then
			redList[k] = {};
			for i,j in pairs(v.stamp_group_list) do
				redList[k][i] = list[j];
			end
		end
	end
	self.btnList:setRedDot(2, redList[self.selectedData.mainIndex]);
end

-- 1成功，0失败
function Lua_StampCompoundWindow:onUpdateEffect(state)
	if self.rsEffect ~= nil then
		self.rsEffect:dispose();
		self.rsEffect = nil;
	end

	if state == 1 then
		self.rsEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_hechengchenggong", "gui_hechengchenggong", 117, 15);
	else
		self.rsEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_hechengshibai", "gui_hechengshibai", 0, 0);
	end
	self.rsEffect:SetRenderQueue(self.infoBg, 100, 2, false);
end

function Lua_StampCompoundWindow:onHelp()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(128541));
end