-- 圣印
Lua_StampHolyWindow  = class("Lua_StampHolyWindow",Lua_Window);
function Lua_StampHolyWindow:ctor()
    self:superCall("ctor");

    self.windowName = "Lua_StampHolyWindow";
    self.skinName = "StampHolyWindow_skin";
end

function Lua_StampHolyWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 865, 515));
	self.dragList:setLocation(0, -53.5, 0);
	self.dragList:setListCell(Lua_StampHolyItem, 115, 865, 1);

	self:updateSuitInfo();

	self:addLuaEvent("UPDATE_STAMP_INFO", self, self.updateSuitInfo);
end

function Lua_StampHolyWindow:updateSuitInfo()
    self.dragList:setLuaArrayData(DataCenter.stampData.stampHolyInfo, false);
end

function Lua_StampHolyWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_StampHolyItem = class("Lua_StampHolyItem", Lua_ListCell);
function Lua_StampHolyItem:ctor(p)
	self:superCall("ctor", p, "StampHolyItem_skin");
end

function Lua_StampHolyItem:buildShowItem()
	self:superCall("buildShowItem");

	self.leftImage = Lua_ToolImage.new(self.content);
	self.leftImage:setDepth(5);
	self.leftImage:setLocation(-350, 0, 0);

	self.subButton:addClickFuntion(self, self.onSubButtonClick);
end

function Lua_StampHolyItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.leftImage.data = data.itemVo;
	self.leftImage:showNumLimit(data.pack_item_num,data.cost_item_num, 2);

	self.baseAttrLab.text = data.stampHolyProp;
	self.addAttrLab.text = data.stampSpecialProp;

	self.subBar:setText(tostring(data.holy_lvl) .. "/" .. tostring(data.getOpenNum));
	self.subBar:setMaxValue(data.getOpenNum);
	self.subBar:setValue(data.holy_lvl);

	self:showRedDot(data.isShowHolyUpgradeRed);
	self.subButton:setBtnEnable(data.isShowHolyUpgradeRed);

	if data.isMaxLvl == false then
		if data.getOpenLvl~= nil then
			self.tipsLab:setEnable(true);
			self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(128533), tostring(data.getOpenLvl));
		else
			self.tipsLab:setEnable(false);
		end
	else
		self.tipsLab:setEnable(true);
		self.tipsLab.text = LanUtil.getValue(128534);
	end
end

function Lua_StampHolyItem:showRedDot(val)
	if val then
		if self.redDot == nil then
			self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 343, 25, 0, 0);
			self.redDot:setDepth(7);
			self.redDot.name = "redDot";
		end
		self.redDot:setEnable(true);
	else
		if self.redDot ~= nil then
			self.redDot:setEnable(false);
		end
	end
end

function Lua_StampHolyItem:onSubButtonClick()
	Lua_ProxyManager.getProxy("Lua_StampProxy"):sUpgradeStampHoly(self.data.holy_id);
end

function Lua_StampHolyItem:dispose()
	if self.leftImage ~= nil then
		self.leftImage:dispose();
		self.leftImage = nil;
	end
	if self.redDot ~= nil then
		self.redDot:dispose();
		self.redDot = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end