-- 魂印强化
Lua_StampIntensifyWindow  = class("Lua_StampIntensifyWindow",Lua_Window);
function Lua_StampIntensifyWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_StampIntensifyWindow";
	self.skinName = "StampIntensifyWindow_skin";
end

function Lua_StampIntensifyWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.isAutomatic = true;

	self.sprObg:SetActive(false);
	self.red:setEnable(false);

	self.helpLab.text = LanUtil.getValue(128502);
	self.subBar:setText(tostring(0) .. "/" .. tostring(0));
	self.subBar:setMaxValue(0);
	self.subBar:setValue(0);

	self.needItemIcon:setEnable(false);
	self.needItemIcon.clickScale = false;
	self.needItemIcon:addClickFuntion(self, self.onOpenStampStoneTips);

	self.centerImage = Lua_ToolImage.new(self.content);
	self.centerImage:setDepth(5);
	self.centerImage:setLocation(161, 91, 0);

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 310, 509));
	self.dragList:setListCell(Lua_StampIntensifyItem, 117, 310, 1);
	self.dragList:setLocation(-290, -53, 0);

	self.autoButton:setBtnEnable(false);
	self.subButton:setBtnEnable(false);
	self.autoButton:addClickFuntion(self, self.onStampAutoClick);-- 自动强化
	self.subButton:addClickFuntion(self, self.onStampSubClick);  -- 强化

	self:addLuaEvent("UPDATE_ON_SELECT_ITEM", self, self.updateIntensifyInfo);  -- 刷新
	self:addLuaEvent("UPDATE_STAMP_INFO", self, self.updateIntensifyInfo);  -- 刷新
	self:addLuaEvent("UPDATE_INTENS_STAMP", self, self.onSuccessEvent); --特效

	self:updateIntensifyInfo();
end

function Lua_StampIntensifyWindow:updateIntensifyInfo()
	local arr = DataCenter.stampData:getStampIntensifyData();
	local len = arr:getSize();
	if len > 0 then
		self.needItemIcon:setEnable(true);

		self.dragList:setLuaArrayData(arr, false);
		self.length = self.dragList.showList:getSize();
		local index = DataCenter.stampData.intensifyIndex;
		if self.length ~= 0 then
			self.dragList:setSelected(index);
			self:onUpSelectItemClick(arr[index]);
			if self.part ~= nil and self.part ~= arr[index].intensifyVo.part then
				self.isAutomatic = false;
				self:onStampAutoClick();
			end
			self.part = arr[index].intensifyVo.part;
		end
	end
end

-- 选择Item
function Lua_StampIntensifyWindow:onUpSelectItemClick(data)
	self.data = data;
	self.vo = data.intensifyVo;

	self.centerImage.data = data.intensifyVo;
	self.centerImage:showStampEff(true);
	self.stampLvLab.text = "Lv." .. data.intensify_lvl;
	self.red:setEnable(data.intensifyVo.isCanIntensify);

	if data.intensifyVo.isMaxLvl ~= true then -- 未达到最大等级
		self.sprObg:SetActive(true);
		self.autoButton:setBtnEnable(true);
		self.subButton:setBtnEnable(true);

		self.subBar:setText(tostring(data.schedule) .. "/" .. tostring(data.intensifyVo.intensify_max_bar));
		self.subBar:setMaxValue(data.intensifyVo.intensify_max_bar);
		self.subBar:setValue(data.schedule);

		local str;
		local haveNum = DataCenter.stampData.stamp_crystal;
		local needNum = data.intensifyVo.intensify_expend;
		if haveNum >= needNum then
			str = haveNum.."/"..needNum;
		else
			str = "[FF1616]"..haveNum.."[-]".."/"..needNum;
		end
		self.useNumLab.text = LanUtil.getValue(128500);
		self.useNumTxt.text = str;
		self.curLvLab.text = LanUtil.formateStr(LanUtil.getValue(128501), tostring(data.intensify_lvl));
		self.nextLvLab.text = "[00E125]" .. data.intensify_lvl + 1 .. "[-]";
		self.curPowerLab.text = data.intensifyVo.stampIntensifyProp;
		self.nextPowerLab.text = data.intensifyVo.stampNextIntensifyProp;
	else
		self.sprObg:SetActive(false);
		self.autoButton:setBtnEnable(false);
		self.subButton:setBtnEnable(false);
		
		local num = LanUtil.formateStr(LanUtil.getValue(128548), tostring(data.schedule));
		self.subBar:setText(num);
		self.subBar:setMaxValue(data.intensifyVo.intensify_max_bar);
		self.subBar:setValue(data.schedule);

		self.useNumLab.text = LanUtil.getValue(128530);
		self.useNumTxt.text = LanUtil.getValue(20);
		self.curLvLab.text = LanUtil.formateStr(LanUtil.getValue(128501), tostring(data.intensify_lvl));
		self.nextLvLab.text = "";
		self.curPowerLab.text = data.intensifyVo.stampIntensifyProp;
		self.nextPowerLab.text = "";
	end

	-- 移除自动强化计时器
	if DataCenter.stampData.isAutomatic == false then
		self.isAutomatic = false;
		self:onStampAutoClick();
	end
end

-- 自动强化
function Lua_StampIntensifyWindow:onStampAutoClick(go)
	if self.isAutomatic == true then
		DataCenter.stampData.isAutomatic = self.isAutomatic;
		self.subButton:removeClickFuntion(self, self.onStampSubClick)
		self.isAutomatic = false
		Lua_CommonUtil.addTimer("auto_Stamp_Timer", 0.3, self, self.onStampSubClick);
		self.autoButton.label = LanUtil.getValue(110563);
	else
		Lua_CommonUtil.removeTimer(self, self.onStampSubClick);
		self.isAutomatic = true;
		self.autoButton.label = LanUtil.getValue(110562);
		self.subButton:addClickFuntion(self, self.onStampSubClick);
	end
end

-- 强化
function Lua_StampIntensifyWindow:onStampSubClick(go)
	if self.vo.isCanIntensify == true then
		self:onAffirmCombineClick();
	else
		if self.vo.isMaxLvl == true then
			OperateAlert.show(LanUtil.getValue(128545));
		else
			if DataCenter.stampData.stamp_crystal < self.vo.intensify_expend then
				OperateAlert.show(LanUtil.getValue(128531));
			end
		end
		self.isAutomatic = false;
		self:onStampAutoClick(); -- 自动强化
		return;
	end
end

function Lua_StampIntensifyWindow:onSuccessEvent()
	if self.effect1 == nil then
		self.effect1 = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_qianghuaziti", "gui_qianghuaziti", 165, -83);
	else
		self.effect1:setEnable(false);
		self.effect1:setEnable(true);
	end
	self.effect1:SetRenderQueue(self.rightInfoBg, 100, 2,false);
end

function Lua_StampIntensifyWindow:onAffirmCombineClick()
	Lua_ProxyManager.getProxy("Lua_StampProxy"):sIntensifyStamp(self.vo.part,self.vo.stamp_type);
end

-- 魂石Tips
function Lua_StampIntensifyWindow:onOpenStampStoneTips()
	Lua_PackUtil.showItemInfo(Lua_ToolVo.new(201050021), false)
end

function Lua_StampIntensifyWindow:dispose()
	if self.centerImage ~=nil then
		self.centerImage:dispose();
		self.centerImage = nil;
	end
	if self.dragList ~=nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	DataCenter.stampData.intensifyIndex = 1;
	Lua_CommonUtil.removeTimer(self,self.onStampSubClick);

	self:superCall("dispose");
end





--------------------------------------------------





Lua_StampIntensifyItem = class("Lua_StampIntensifyItem", Lua_ListCell);
function Lua_StampIntensifyItem:ctor(p)
	self:superCall("ctor", p, "StampIntensifyItem_skin");
end

function Lua_StampIntensifyItem:buildShowItem()
	self:superCall("buildShowItem");

	self.leftImage = Lua_ToolImage.new(self.content);
	self.leftImage:setDepth(5);
	self.leftImage:setLocation(-95, 1.5, 0);
end

function Lua_StampIntensifyItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.leftImage.data = data.intensifyVo;
	self.leftImage:showStampEff(true);

	self.name.text = data.intensifyVo.colorName;
	self.lvlLab.text = LanUtil.formateStr(LanUtil.getValue(128528),tostring(data.intensifyVo.intensify_lvl));

	self.redDot:setEnable(data.intensifyVo.isCanIntensify); 
end

function Lua_StampIntensifyItem:onPlayerSoundClick(go)
	DataCenter.stampData.isAutomatic = false;
	DataCenter.stampData.intensifyIndex = DataCenter.stampData:getIntensifyIndex(self.data.intensifyVo.part);
	Lua_MsgUtil.callFunc("UPDATE_ON_SELECT_ITEM");
end

function Lua_StampIntensifyItem:checkOutBound(showRect)
	if self.data == nil then
		self.inViewEffect = false;
		return;
	end

	local rect = Lua_Rectangle.new(self.itemX - 50, self.itemY - 30, 70,60);
	self.inViewEffect = showRect:containeRect(rect) and self.data.intensifyVo.color >= 2;
	self:updateEffectState();
end

function Lua_StampIntensifyItem:updateEffectState()
	if self.inViewEffect == true then
		if self.leftImage.stampEff == nil then
			self.leftImage:showStampEff(true);
		end
	else
		self.leftImage:showStampEff(false);
	end
end

function Lua_StampIntensifyItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	self.selectIcon:setEnable(val);
end

function Lua_StampIntensifyItem:dispose()
	if self.leftImage ~= nil then
		self.leftImage:dispose();
		self.leftImage = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end