checkRequire("Lua_StampItem");
checkRequire("Lua_StampPackCellsItem");
Lua_StampPanel = class("Lua_StampPanel", Lua_DisplayObject);
function Lua_StampPanel:ctor(p)
	self:superCall("ctor", p, "StampPanel_skin");
end

function Lua_StampPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.stampIcon.clickScale = false;
	self.stampIcon:addClickFuntion(self, self.onOpenStampStoneTips);

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 472, 540));
	self.dragList:setLocation(257, 2, 0);
	self.dragList:setListCell(Lua_StampPackCellsItem, 94, 94, 5);

	self.fightNum = Lua_NumberImage.new(self.content);
	self.fightNum.numWidth = 16;
	self.fightNum.prefix = "ui_minghun_";
	self.fightNum:setDepth(5);
	self.fightNum:setLocation(-463, -229, 0);

	self.holyBtn:addClickFuntion(self, self.onOpenStampHolyClick); -- 打开圣魂
	self.allUpBtn:addClickFuntion(self, self.onOpenSeampAllClick); -- 属性加成
	self.help:addClickFuntion(self, self.onHelpClick); -- 说明

	self.allShowButton:addClickFuntion(self, self.onOpenAllShowClick); -- 套装总览
	self.resolveButton:addClickFuntion(self, self.onOpenSoulResolveClick); -- 魂印分解
	self.intensifyButton:addClickFuntion(self, self.onOpenIntensifyClick); -- 魂印强化
	self.compoundButton:addClickFuntion(self, self.onOpenCompoundClick); -- 魂印合成

	local poses = {{-403, -149}, {-480, -43}, {-467, 85}, {-371, 173}, {-232, 173}, {-141, 81},
		{-133, -57}, {-250, -172}, {-362, -58}, {-250, 57}, {-253, -51}};
	local item;
	self.itemArr = Array();
	for i,v in ipairs(poses) do
		item = Lua_StampItem.new(self.content);
		item:setLocation(v[1], v[2], 0);
		item:setDepth(5);
		item:setCanClick(true);
		item:setStampNnmetype(i);
		self.itemArr:add(item);
	end

	Lua_ProxyManager.getProxy("Lua_StampProxy"):sOpenStampPanelInfo();
	self:addLuaEvent("UPDATE_STAMP_INFO", self, self.openStampPanelInfo); -- 打开面板
	self:addLuaEvent("PACK_STAMP_UPDATE", self, self.openStampPanelInfo); -- 刷新背包
end

function Lua_StampPanel:openStampPanelInfo()
	self.stampLab.text = DataCenter.stampData.stamp_crystal;
	local data = DataCenter.stampData.stampHolesInfo;
	for k,v in pairs(data) do
		if v.stamp_part ~= nil then
			self.itemArr[v.stamp_part]:setStampInfo(v);
		end
	end
	self.fightNum.num = DataCenter.stampData.getStampAllForce;

	self:onUpdatePackItemInfo();
	self:updateIsShowRed();
end

function Lua_StampPanel:onUpdatePackItemInfo()
	local packArry = Array()
	local len = DataCenter.stampUtil.pack_size;
	local bagData = DataCenter.packData:getBagType(Lua_PackData.STAMP_PACK); --魂印-背包
	local arr = bagData:getItemsBySubType({Lua_PackTypeDefine.STAMP_ITEM});
	for i = 1, len do
	if arr[i] ~= nil then
		local weight = 0;
		if arr[i].stamp_type  == 0 then
			weight = arr[i].color; 
		else
			if arr[i].isSameType == true then
				if arr[i].isShowItemReplaceRed == true then
					weight = 200000 + arr[i].color * 1000 + arr[i].order;
				else
					weight = 100000 + arr[i].color * 1000 + arr[i].order;
				end
			else
				if DataCenter.roleData.level >= arr[i].useLvl then -- 可穿戴
					weight = 300000 + arr[i].color * 1000 + arr[i].order;
				else
					weight = 100000 + arr[i].color * 1000 + arr[i].order;
				end
			end
		end
		packArry:add({data = arr[i], weight = weight});
	else
		packArry:add({data = nil, weight = 0});
	end
	end
	packArry:sort("weight", true);
	self.dragList:setLuaArrayData(packArry, false);
end

-- 红点更新
function Lua_StampPanel:updateIsShowRed()
    local isShowHolyRed = DataCenter.stampData:isShowStampHolyRed(); -- 圣魂
    local isShowIntensifyRed = DataCenter.stampData:isShowStampIntensifyRed(); -- 魂印强化
    local isShowResolveRed = DataCenter.stampData:isShowStampResolveRed(); -- 魂印分解
    local isShowCompoundRed = DataCenter.stampData:isShowStampCompoundRed(); -- 魂印合成
	self.holyRed:setEnable(isShowHolyRed);
	self.intensifyRed:setEnable(isShowIntensifyRed);
	self.resolveRed:setEnable(isShowResolveRed);
	self.compoundRed:setEnable(isShowCompoundRed);
end

-- 魂石Tips
function Lua_StampPanel:onOpenStampStoneTips()
	Lua_PackUtil.showItemInfo(Lua_ToolVo.new(201050021), false)
end

function Lua_StampPanel:onHelpClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(128529));
end

-- 打开圣魂
function Lua_StampPanel:onOpenStampHolyClick()
	Lua_WindowUtil.openWin("Lua_StampHolyWindow");
end

-- 属性加成
function Lua_StampPanel:onOpenSeampAllClick()
	Lua_WindowUtil.openWin("Lua_SeampAllAttributeWindow");
end

-- 套装总览
function Lua_StampPanel:onOpenAllShowClick()
	Lua_WindowUtil.openWin("Lua_StampSuitWindow");
end

-- 魂印分解
function Lua_StampPanel:onOpenSoulResolveClick()
	Lua_WindowUtil.openWin("Lua_StampResolveWindow");
end

-- 魂印强化
function Lua_StampPanel:onOpenIntensifyClick()
	Lua_WindowUtil.openWin("Lua_StampIntensifyWindow");
end

-- 魂印合成
function Lua_StampPanel:onOpenCompoundClick()
	Lua_WindowUtil.openWin("Lua_StampCompoundWindow");
end

function Lua_StampPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.fightNum ~= nil then
		self.fightNum:dispose();
		self.fightNum = nil;
	end

	self:superCall("dispose");
end