-- 魂印套装总览
checkRequire("Lua_StampItem");
Lua_StampSuitWindow = class("Lua_StampSuitWindow", Lua_SecondSizeWindow)
function Lua_StampSuitWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_StampSuitWindow";
	self.skinName = "StampSuitWindow_skin";
	self.titleText = LanUtil.getValue(128503);
end

function Lua_StampSuitWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 236, 474));
	self.dragList:setLocation(-432, -65, 0);
	self.dragList:setListCell(Lua_StampSuitItem, 95, 236, 1);

	local poses = {{-136, -189}, {-211, -82}, {-199, 49}, {-103, 134}, {34, 129}, {126, 47}, {133, -92},
		{16, -208}, {-94, -94}, {15, 22}, {14, -85}};
	local item;
	self.itemArr = Array();
	for i, v in ipairs(poses) do
		item = Lua_StampItem.new(self.content);
		item:setLocation(v[1], v[2], 0);
		item:setDepth(5);
		item:setCanClick(true);
		item:setStampNnmetype(i);
		self.itemArr:add(item);
	end

	self.fightNum = Lua_NumberImage.new(self.content);
	self.fightNum.numWidth = 16;
	self.fightNum.prefix = "ui_minghun_";
	self.fightNum:setDepth(5);
	self.fightNum:setLocation(3, -277, 0);

	self.textArea = Lua_TextArea.new(self.content, 277, 363);
	self.textArea.insideItem.label.fontSize = 22;
	self.textArea.insideItem.label.spacingY = 5;
	self.textArea:setLocation(256, 160, 0);

	self.subButton:addClickFuntion(self, self.onOpenWindowClick);

	self:addLuaEvent("UPDATE_SUIT_SELECT_ITEM", self, self.onUpSelectItemClick);
	self:addLuaEvent("UPDATE_STAMP_INFO", self, self.updateSuitInfo);
	self:updateSuitInfo();
end

function Lua_StampSuitWindow:updateSuitInfo()
	self.dragList:setLuaArrayData(DataCenter.stampUtil.getSuitConfigInfo, false);
	self.dragList:setSelected(1);
	self.dragList.showList[1]:onPlayerSoundClick();
end

function Lua_StampSuitWindow:onUpSelectItemClick(data)
	-- 属性显示
	self.textArea:setText(data.getSuitAllProp);
	self.fightNum.num = data.getSuitAllForce;

	-- 套装显示
	for i = 1, self.itemArr:getSize() do
		self.itemArr[i]:stampSuitinfo(data.stampSuitinfo[i]);
	end
end

function Lua_StampSuitWindow:onOpenWindowClick()
	Lua_WindowUtil.openWin("Lua_MultipleServersWindow", WinParam.ACTION_OPEN, {openIdx = 2});
	Lua_WindowUtil.openWin("Lua_StampWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_StampSuitWindow", WinParam.ACTION_CLOSE);
end

function Lua_StampSuitWindow:dispose()
	if self.dragList ~=nil then
		self.dragList:dispose();
		self.dragList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_StampSuitItem = class("Lua_StampSuitItem", Lua_ListCell);
function Lua_StampSuitItem:ctor(p)
	self:superCall("ctor", p, "StampSuitItem_skin");
end

function Lua_StampSuitItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_StampSuitItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.name.text = data.suit_name;
	self.num.text = data.suit_adorn_num.."/"..data.suit_max_num;
end

function Lua_StampSuitItem:onPlayerSoundClick(go)
    Lua_MsgUtil.callFunc("UPDATE_SUIT_SELECT_ITEM", self.data);
end

function Lua_StampSuitItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val then
		self.bg:setAltas("common_atlas_1", "ui_common_btn_p5");
	else
		self.bg:setAltas("common_atlas_1", "ui_common_btn_p6");
	end
end

function Lua_StampSuitItem:dispose()
	self.data = nil;
	self:superCall("dispose");
end