-- 魂印item
Lua_StampItem = class("Lua_StampItem", Lua_DisplayObject);
function Lua_StampItem:ctor(p)
    self:superCall("ctor", p, "StampItem_skin");
end

function Lua_StampItem:buildShowItem()
    self:superCall("buildShowItem");

    self.stampIcon.clickScale = false;
    self.bg:addLoadCompleteFun(self, self.onLoadCompleteImg);
end

function Lua_StampItem:onLoadCompleteImg()
	self.bg:resetSize();
end

function Lua_StampItem:setStampNnmetype(val)
    self.stampType = val;
	self.content.name = "Lua_StampItem"..tostring(val);
end

function Lua_StampItem:setStampInfo(data)
	self._data = data;
	self.vo = data.stampVo;

	if self.stampType == 11 then
		self.bg:setAltas("minghun_atlas", "ui_minghun_icon_5");
	else
		self.bg:setAltas("minghun_atlas", "ui_minghun_icon_1");
	end

	self.stampDiBg:setAltas("minghun_atlas", "ui_minghun_equip_"..self.stampType);
	if data.unlock == 1 then -- 已开启
		if data.stamp_id ~= 0 and data.stamp_id ~= nil then
			self.stampIcon:setAltas(tostring(data.stampVo.atlas), tostring(data.stampVo.referenceId));
			self.stampIcon:setEnable(true);
			self.stampDiBg:setEnable(false);
			self:showStampEff(true);
		else -- 未穿戴
			self.stampIcon:setEnable(false);
			self.stampDiBg:setEnable(true);
			self:showStampEff(false);
		end
		self.lock:setEnable(false);
		self.stampLab:setEnable(false);
		self:showRedDot(data.isShowStampDressRed or data.isShowStampReplaceRed);
	else
		self.stampLab.text = data.getOpenLvl;
		self.lock:setEnable(true);
		self.stampIcon:setEnable(false);
		self.stampDiBg:setEnable(false);
		self:showStampEff(false);
		self:showRedDot(false);
	end
	self:showEffect();
end

function Lua_StampItem:stampSuitinfo(data)
	self:showRedDot(false);
	if data ~= nil then -- 已开启
		self.vo = data;
		self.stampIcon:setAltas(tostring(data.atlas), tostring(data.referenceId));
		
		self.lock:setEnable(false);
		self.stampLab:setEnable(false);
		self.stampIcon:setEnable(true);
		self.stampDiBg:setEnable(false);

		self:showStampEff(true);
		self.stampEff:setSacle(0.9, 0.9, 0.9);
	else
		self.lock:setEnable(true);
		self.stampLab:setEnable(false);
		self.stampIcon:setEnable(false);
		self.stampDiBg:setEnable(false);

		self:showStampEff(false);
	end

	if self.stampType == 11 then
		self.bg:setAltas("minghun_atlas", "ui_minghun_icon_5");
	else
		self.bg:setAltas("minghun_atlas", "ui_minghun_icon_1");
	end
end

-- 背景添加点击方法
function Lua_StampItem:setCanClick(val)
	if val == true then
		self.stampIcon.mouseEnable = true;
		self.stampIcon:addClickFuntion(self, self.onIconClick);
	else
		self.stampIcon.mouseEnable = false;
		self.stampIcon:removeClickFuntion(self, self.onIconClick);
	end
end

function Lua_StampItem:setDepth(val)
	self:superCall("setDepth", val);

	self.bg:setDepth(val);
	self.stampDiBg:setDepth(val + 1);
	self.stampIcon:setDepth(val + 2);
	self.stampLab:setDepth(val + 3);
	self.lock:setDepth(val + 5);
end

function Lua_StampItem:showRedDot(val)
	if val then
		if self._redDot == nil then
			self._redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 34, 28, 0, 0);
			self._redDot:setDepth(10);
			self._redDot.name = "redDot";
		end
		self._redDot:setEnable(true);
	else
		if self._redDot ~= nil then
			self._redDot:setEnable(false);
		end
	end
end

function Lua_StampItem:showEffect()
	if self._data.stamp_id ~= 0 then
		if self.vo.stamp_part < 11 and self.vo.stamp_part > 6 then
			if self.effect == nil then
				self.effect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_taozhuangzonglan2", "gui_taozhuangzonglan2", 0, 0);
			end
			self.effect:SetRenderQueue(self.stampIcon, 10, 2,false);
			self.effect:setSacle(1, 1, 1);
		else
			if self.effect ~= nil then
				self.effect:dispose();
				self.effect = nil;
			end
		end

		if self.vo.stamp_part == 11 then
			if self.effect1 == nil then
				self.effect1 = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_taozhuangzonglan", "gui_taozhuangzonglan", 0, 0);
			end
			self.effect1:SetRenderQueue(self.stampIcon, -10, 20,false);
			self.effect1:setSacle(1, 1, 1);
		else
			if self.effect1 ~= nil then
				self.effect1:dispose();
				self.effect1 = nil;
			end
		end
	else
		if self.effect ~= nil then
			self.effect:dispose();
			self.effect = nil;
		end
		if self.effect1 ~= nil then
			self.effect1:dispose();
			self.effect1 = nil;
		end
	end
end

function Lua_StampItem:showStampEff(bShowEff)
	bShowEff = bShowEff == nil and false or bShowEff;
	if self.vo ~= nil and bShowEff == true then
		local str = self.vo.stamp_effect;
		if str == nil then
			if self.stampEff ~= nil then
				self.stampEff:dispose();
				self.stampEff = nil;
			end
			return;
		end

		if self.stampEff == nil then
			self.stampEff = UICreate.createUIEffect(self.content, "/effects/scsEffects/" .. str, str, 0, 0);
			self.stampEff:setLoop(true);
			self.stampEff:SetRenderQueue(self.stampIcon, 5, 2, false);
		end
		self.stampEff:setUrl("/effects/scsEffects/" .. str, str);
	else
		if self.stampEff ~= nil then
			self.stampEff:dispose();
			self.stampEff = nil;
		end
	end
end

function Lua_StampItem:onIconClick(go)
	Lua_PackUtil.showItemInfo(self.vo, false, nil, true);
end

function Lua_StampItem:dispose()
	if self.effect ~= nil then
		self.effect:dispose();
		self.effect = nil;
	end
	if self.effect1 ~= nil then
		self.effect1:dispose();
		self.effect1 = nil;
	end
	if self.stampEff ~= nil then
		self.stampEff:dispose();
		self.stampEff = nil;
	end
	self:superCall("dispose");
end