-- 魂印背包Item
Lua_StampPackCellsItem = class("Lua_StampPackCellsItem", Lua_ListCell);
function Lua_StampPackCellsItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_StampPackCellsItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImage = Lua_ToolImage.new(self.content);
	self.itemImage:setDepth(3);
	self.itemImage:setLocation(0, 6, 0);
	self.itemImage:setCanClick(false);
end

function Lua_StampPackCellsItem:setData(data)
	if data == nil then
		return;
	end
	self._data = data.data;

	if data.data ~= nil then
		self.itemImage.data = data.data;
		self.itemImage:showStampEff(data.data.stamp_type ~= 0);
	else
		self.itemImage.data = nil;
	end
end

function Lua_StampPackCellsItem:checkOutBound(showRect)
	if self._data == nil then
		return;
	end

	local width = self.itemImage.item_bg.width;
	local height = self.itemImage.item_bg.height;
	local rect = Lua_Rectangle.new(self.itemX - width / 2, self.itemY - height / 2 + 6, width, height);
	self.itemImage:showStampEff(showRect:containeRect(rect) and self._data.color >= 2);
end

function Lua_StampPackCellsItem:onPlayerSoundClick(go)
	if self._data ~= nil then
		Lua_PackUtil.showItemInfo(self._data, false, nil, true);
	end
end

function Lua_StampPackCellsItem:dispose()
	if self.itemImage ~= nil then
		self.itemImage:dispose();
		self.itemImage = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end